library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity simple_axi_memiface32_sim is
end simple_axi_memiface32_sim;

architecture RTL of simple_axi_memiface32_sim is

  component simple_axi_memiface_32
    port (
      clk : in std_logic;
      reset : in std_logic;
      data_address : in std_logic_vector(32-1 downto 0);
      data_din : in std_logic_vector(32-1 downto 0);
      data_dout : out std_logic_vector(32-1 downto 0);
      data_we : in std_logic;
      data_oe : in std_logic;
      data_length : out std_logic_vector(32-1 downto 0);
      busy : out std_logic;
      axi_reader_ARADDR : out std_logic_vector(32-1 downto 0);
      axi_reader_ARLEN : out std_logic_vector(8-1 downto 0);
      axi_reader_ARVALID : out std_logic;
      axi_reader_ARREADY : in std_logic;
      axi_reader_ARSIZE : out std_logic_vector(3-1 downto 0);
      axi_reader_ARBURST : out std_logic_vector(2-1 downto 0);
      axi_reader_ARCACHE : out std_logic_vector(4-1 downto 0);
      axi_reader_ARPROT : out std_logic_vector(3-1 downto 0);
      axi_reader_RDATA : in std_logic_vector(32-1 downto 0);
      axi_reader_RRESP : in std_logic_vector(2-1 downto 0);
      axi_reader_RLAST : in std_logic;
      axi_reader_RVALID : in std_logic;
      axi_reader_RREADY : out std_logic;
      axi_writer_AWADDR : out std_logic_vector(32-1 downto 0);
      axi_writer_AWLEN : out std_logic_vector(8-1 downto 0);
      axi_writer_AWVALID : out std_logic;
      axi_writer_AWSIZE : out std_logic_vector(3-1 downto 0);
      axi_writer_AWBURST : out std_logic_vector(2-1 downto 0);
      axi_writer_AWCACHE : out std_logic_vector(4-1 downto 0);
      axi_writer_AWPROT : out std_logic_vector(3-1 downto 0);
      axi_writer_AWREADY : in std_logic;
      axi_writer_WDATA : out std_logic_vector(32-1 downto 0);
      axi_writer_WLAST : out std_logic;
      axi_writer_WVALID : out std_logic;
      axi_writer_WREADY : in std_logic;
      axi_writer_WSTRB : out std_logic_vector(4-1 downto 0);
      axi_writer_BRESP : in std_logic_vector(2-1 downto 0);
      axi_writer_BVALID : in std_logic;
      axi_writer_BREADY : out std_logic
    );
  end component simple_axi_memiface_32;


  signal clk : std_logic := '0';
  signal reset : std_logic := '0';
  signal counter : signed(32-1 downto 0) := (others => '0');
  type Type_main is (
    main_IDLE,
    main_S0  
  );
  signal main : Type_main := main_IDLE;
  signal main_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0001 : signed(32-1 downto 0);
  signal tmp_0002 : std_logic;
  signal tmp_0003 : std_logic;
  signal tmp_0004 : std_logic;
  signal tmp_0005 : std_logic;
  signal U_clk : std_logic;
  signal U_reset : std_logic;
  signal U_data_address : std_logic_vector(32-1 downto 0) := (others => '0');
  signal U_data_din : std_logic_vector(32-1 downto 0) := (others => '0');
  signal U_data_dout : std_logic_vector(32-1 downto 0);
  signal U_data_we : std_logic;
  signal U_data_oe : std_logic := '0';
  signal U_data_length : std_logic_vector(32-1 downto 0);
  signal U_busy : std_logic;
  signal U_axi_reader_ARADDR : std_logic_vector(32-1 downto 0);
  signal U_axi_reader_ARLEN : std_logic_vector(8-1 downto 0);
  signal U_axi_reader_ARVALID : std_logic;
  signal U_axi_reader_ARREADY : std_logic := '0';
  signal U_axi_reader_ARSIZE : std_logic_vector(3-1 downto 0);
  signal U_axi_reader_ARBURST : std_logic_vector(2-1 downto 0);
  signal U_axi_reader_ARCACHE : std_logic_vector(4-1 downto 0);
  signal U_axi_reader_ARPROT : std_logic_vector(3-1 downto 0);
  signal U_axi_reader_RDATA : std_logic_vector(32-1 downto 0) := (others => '0');
  signal U_axi_reader_RRESP : std_logic_vector(2-1 downto 0) := (others => '0');
  signal U_axi_reader_RLAST : std_logic := '0';
  signal U_axi_reader_RVALID : std_logic := '0';
  signal U_axi_reader_RREADY : std_logic;
  signal U_axi_writer_AWADDR : std_logic_vector(32-1 downto 0);
  signal U_axi_writer_AWLEN : std_logic_vector(8-1 downto 0);
  signal U_axi_writer_AWVALID : std_logic;
  signal U_axi_writer_AWSIZE : std_logic_vector(3-1 downto 0);
  signal U_axi_writer_AWBURST : std_logic_vector(2-1 downto 0);
  signal U_axi_writer_AWCACHE : std_logic_vector(4-1 downto 0);
  signal U_axi_writer_AWPROT : std_logic_vector(3-1 downto 0);
  signal U_axi_writer_AWREADY : std_logic;
  signal U_axi_writer_WDATA : std_logic_vector(32-1 downto 0);
  signal U_axi_writer_WLAST : std_logic;
  signal U_axi_writer_WVALID : std_logic;
  signal U_axi_writer_WREADY : std_logic;
  signal U_axi_writer_WSTRB : std_logic_vector(4-1 downto 0);
  signal U_axi_writer_BRESP : std_logic_vector(2-1 downto 0) := (others => '0');
  signal U_axi_writer_BVALID : std_logic := '0';
  signal U_axi_writer_BREADY : std_logic;
  signal tmp_0006 : std_logic;
  signal tmp_0007 : std_logic;
  signal tmp_0008 : std_logic;
  signal tmp_0009 : std_logic;
  signal tmp_0010 : std_logic;
  signal tmp_0011 : std_logic;

begin


  -- expressions
  tmp_0001 <= counter + 1;
  tmp_0002 <= '1' when counter >= 0 else '0';
  tmp_0003 <= '1' when counter <= 8 else '0';
  tmp_0004 <= tmp_0002 and tmp_0003;
  tmp_0005 <= '1' when tmp_0004 = '1' else '0';
  tmp_0006 <= '1' when counter > 100 else '0';
  tmp_0007 <= '1' when tmp_0006 = '1' else '0';
  tmp_0008 <= '1' when counter > 110 else '0';
  tmp_0009 <= '1' when tmp_0008 = '1' else '0';
  tmp_0010 <= '1' when counter > 150 else '0';
  tmp_0011 <= '1' when tmp_0010 = '1' else '0';

  -- sequencers
  process
  begin
    -- state main = main_IDLE
    main <= main_S0;
    wait for 10 ns;
    -- state main = main_S0
    main <= main_IDLE;
    wait for 10 ns;
  end process;


  process(main)
  begin
    if main = main_IDLE then
      clk <= '0';
    elsif main = main_S0 then
      clk <= '1';
    end if;
  end process;

  process(main)
  begin
    if main = main_IDLE then
      reset <= tmp_0005;
    end if;
  end process;

  process(main)
  begin
    if main = main_IDLE then
      counter <= tmp_0001;
    elsif main = main_S0 then
      counter <= tmp_0001;
    end if;
  end process;

  U_clk <= clk;

  U_reset <= reset;

  U_data_we <= tmp_0007;

  U_axi_writer_AWREADY <= tmp_0009;

  U_axi_writer_WREADY <= tmp_0011;


  inst_U : simple_axi_memiface_32
  port map(
    clk => U_clk,
    reset => U_reset,
    data_address => U_data_address,
    data_din => U_data_din,
    data_dout => U_data_dout,
    data_we => U_data_we,
    data_oe => U_data_oe,
    data_length => U_data_length,
    busy => U_busy,
    axi_reader_ARADDR => U_axi_reader_ARADDR,
    axi_reader_ARLEN => U_axi_reader_ARLEN,
    axi_reader_ARVALID => U_axi_reader_ARVALID,
    axi_reader_ARREADY => U_axi_reader_ARREADY,
    axi_reader_ARSIZE => U_axi_reader_ARSIZE,
    axi_reader_ARBURST => U_axi_reader_ARBURST,
    axi_reader_ARCACHE => U_axi_reader_ARCACHE,
    axi_reader_ARPROT => U_axi_reader_ARPROT,
    axi_reader_RDATA => U_axi_reader_RDATA,
    axi_reader_RRESP => U_axi_reader_RRESP,
    axi_reader_RLAST => U_axi_reader_RLAST,
    axi_reader_RVALID => U_axi_reader_RVALID,
    axi_reader_RREADY => U_axi_reader_RREADY,
    axi_writer_AWADDR => U_axi_writer_AWADDR,
    axi_writer_AWLEN => U_axi_writer_AWLEN,
    axi_writer_AWVALID => U_axi_writer_AWVALID,
    axi_writer_AWSIZE => U_axi_writer_AWSIZE,
    axi_writer_AWBURST => U_axi_writer_AWBURST,
    axi_writer_AWCACHE => U_axi_writer_AWCACHE,
    axi_writer_AWPROT => U_axi_writer_AWPROT,
    axi_writer_AWREADY => U_axi_writer_AWREADY,
    axi_writer_WDATA => U_axi_writer_WDATA,
    axi_writer_WLAST => U_axi_writer_WLAST,
    axi_writer_WVALID => U_axi_writer_WVALID,
    axi_writer_WREADY => U_axi_writer_WREADY,
    axi_writer_WSTRB => U_axi_writer_WSTRB,
    axi_writer_BRESP => U_axi_writer_BRESP,
    axi_writer_BVALID => U_axi_writer_BVALID,
    axi_writer_BREADY => U_axi_writer_BREADY
  );


end RTL;
