library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity conv64to24 is
  port (
    clk : in std_logic;
    reset : in std_logic;
    fifo64_re : out std_logic;
    fifo64_din : in std_logic_vector(64-1 downto 0);
    fifo64_empty : in std_logic;
    fifo64_rd_count : in std_logic_vector(32-1 downto 0);
    fifo24_we : out std_logic;
    fifo24_dout : out std_logic_vector(24-1 downto 0);
    fifo24_full : in std_logic;
    fifo24_wr_count : in std_logic_vector(32-1 downto 0)
  );
end conv64to24;

architecture RTL of conv64to24 is


  signal clk_sig : std_logic;
  signal reset_sig : std_logic;
  signal fifo64_re_sig : std_logic := '0';
  signal fifo64_din_sig : std_logic_vector(64-1 downto 0);
  signal fifo64_empty_sig : std_logic;
  signal fifo64_rd_count_sig : std_logic_vector(32-1 downto 0);
  signal fifo24_we_sig : std_logic := '0';
  signal fifo24_dout_sig : std_logic_vector(24-1 downto 0) := (others => '0');
  signal fifo24_full_sig : std_logic;
  signal fifo24_wr_count_sig : std_logic_vector(32-1 downto 0);

  signal synthesier_scala_tmp_0 : signed(64-1 downto 0) := (others => '0');
  type Type_main is (
    main_IDLE,
    main_S_0,
    main_S_1,
    main_S_2,
    main_S_3,
    main_S_4,
    main_S_5,
    main_S_6,
    main_S_7,
    main_S_8,
    main_S_9,
    main_S_10,
    main_S_11  
  );
  signal main : Type_main := main_IDLE;
  signal main_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0001 : std_logic;
  signal tmp_0002 : std_logic_vector(64-1 downto 0);
  signal tmp_0003 : std_logic_vector(24-1 downto 0);
  signal tmp_0004 : std_logic_vector(64-1 downto 0);
  signal tmp_0005 : std_logic_vector(40-1 downto 0);
  signal tmp_0006 : std_logic_vector(64-1 downto 0);
  signal tmp_0007 : signed(64-1 downto 0);
  signal tmp_0008 : signed(24-1 downto 0);
  signal tmp_0009 : signed(64-1 downto 0);
  signal tmp_0010 : std_logic_vector(64-1 downto 0);
  signal tmp_0011 : std_logic_vector(8-1 downto 0);
  signal tmp_0012 : signed(64-1 downto 0);
  signal tmp_0013 : signed(16-1 downto 0);
  signal tmp_0014 : std_logic_vector(24-1 downto 0);
  signal tmp_0015 : std_logic_vector(64-1 downto 0);
  signal tmp_0016 : std_logic_vector(56-1 downto 0);
  signal tmp_0017 : std_logic_vector(64-1 downto 0);
  signal tmp_0018 : signed(64-1 downto 0);
  signal tmp_0019 : signed(24-1 downto 0);
  signal tmp_0020 : signed(64-1 downto 0);
  signal tmp_0021 : signed(64-1 downto 0);
  signal tmp_0022 : signed(24-1 downto 0);
  signal tmp_0023 : signed(64-1 downto 0);
  signal tmp_0024 : std_logic_vector(64-1 downto 0);
  signal tmp_0025 : std_logic_vector(16-1 downto 0);
  signal tmp_0026 : signed(64-1 downto 0);
  signal tmp_0027 : signed(8-1 downto 0);
  signal tmp_0028 : std_logic_vector(24-1 downto 0);
  signal tmp_0029 : std_logic_vector(64-1 downto 0);
  signal tmp_0030 : std_logic_vector(48-1 downto 0);
  signal tmp_0031 : std_logic_vector(64-1 downto 0);
  signal tmp_0032 : signed(64-1 downto 0);
  signal tmp_0033 : signed(24-1 downto 0);
  signal tmp_0034 : signed(64-1 downto 0);
  signal tmp_0035 : signed(64-1 downto 0);
  signal tmp_0036 : signed(24-1 downto 0);
  signal tmp_0037 : std_logic;
  signal tmp_0038 : std_logic;
  signal tmp_0039 : std_logic;

begin

  clk_sig <= clk;
  reset_sig <= reset;
  fifo64_re <= fifo64_re_sig;
  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        fifo64_re_sig <= '0';
      else
        if main = main_S_1 then
          fifo64_re_sig <= '1';
        elsif main = main_S_2 then
          fifo64_re_sig <= '0';
        elsif main = main_S_3 then
          fifo64_re_sig <= '1';
        elsif main = main_S_4 then
          fifo64_re_sig <= '0';
        elsif main = main_S_6 then
          fifo64_re_sig <= '1';
        elsif main = main_S_7 then
          fifo64_re_sig <= '0';
        elsif main = main_S_9 then
          fifo64_re_sig <= '1';
        elsif main = main_S_9 then
          fifo64_re_sig <= '0';
        else
          fifo64_re_sig <= '0';
        end if;
      end if;
    end if;
  end process;

  fifo64_din_sig <= fifo64_din;
  fifo64_empty_sig <= fifo64_empty;
  fifo64_rd_count_sig <= fifo64_rd_count;
  fifo24_we <= fifo24_we_sig;
  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        fifo24_we_sig <= '0';
      else
        if main = main_S_3 then
          fifo24_we_sig <= '1';
        elsif main = main_S_4 then
          fifo24_we_sig <= '1';
        elsif main = main_S_5 then
          fifo24_we_sig <= '1';
        elsif main = main_S_6 then
          fifo24_we_sig <= '1';
        elsif main = main_S_7 then
          fifo24_we_sig <= '1';
        elsif main = main_S_8 then
          fifo24_we_sig <= '1';
        elsif main = main_S_9 then
          fifo24_we_sig <= '1';
        elsif main = main_S_10 then
          fifo24_we_sig <= '1';
        elsif main = main_S_11 then
          fifo24_we_sig <= '0';
        else
          fifo24_we_sig <= '0';
        end if;
      end if;
    end if;
  end process;

  fifo24_dout <= fifo24_dout_sig;
  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        fifo24_dout_sig <= (others => '0');
      else
        if main = main_S_3 then
          fifo24_dout_sig <= tmp_0003;
        elsif main = main_S_4 then
          fifo24_dout_sig <= std_logic_vector(tmp_0008);
        elsif main = main_S_5 then
          fifo24_dout_sig <= tmp_0014;
        elsif main = main_S_6 then
          fifo24_dout_sig <= std_logic_vector(tmp_0019);
        elsif main = main_S_7 then
          fifo24_dout_sig <= std_logic_vector(tmp_0022);
        elsif main = main_S_8 then
          fifo24_dout_sig <= tmp_0028;
        elsif main = main_S_9 then
          fifo24_dout_sig <= std_logic_vector(tmp_0033);
        elsif main = main_S_10 then
          fifo24_dout_sig <= std_logic_vector(tmp_0036);
        end if;
      end if;
    end if;
  end process;

  fifo24_full_sig <= fifo24_full;
  fifo24_wr_count_sig <= fifo24_wr_count;

  -- expressions
  tmp_0001 <= '1' when signed(fifo64_rd_count_sig) > 100 else '0';
  tmp_0002 <= fifo64_din_sig;
  tmp_0003 <= tmp_0002(24 - 1 downto 0);
  tmp_0004 <= (24-1 downto 0 => '0') & fifo64_din_sig(63 downto 24);
  tmp_0005 <= tmp_0004(40 - 1 downto 0);
  tmp_0006 <= (64-1 downto 40 => '0') & tmp_0005;
  tmp_0007 <= synthesier_scala_tmp_0;
  tmp_0008 <= tmp_0007(24 - 1 downto 0);
  tmp_0009 <= (24-1 downto 0 => '0') & synthesier_scala_tmp_0(63 downto 24);
  tmp_0010 <= fifo64_din_sig;
  tmp_0011 <= tmp_0010(8 - 1 downto 0);
  tmp_0012 <= synthesier_scala_tmp_0;
  tmp_0013 <= tmp_0012(16 - 1 downto 0);
  tmp_0014 <= tmp_0011 & std_logic_vector(tmp_0013);
  tmp_0015 <= (8-1 downto 0 => '0') & fifo64_din_sig(63 downto 8);
  tmp_0016 <= tmp_0015(56 - 1 downto 0);
  tmp_0017 <= (64-1 downto 56 => '0') & tmp_0016;
  tmp_0018 <= synthesier_scala_tmp_0;
  tmp_0019 <= tmp_0018(24 - 1 downto 0);
  tmp_0020 <= (24-1 downto 0 => '0') & synthesier_scala_tmp_0(63 downto 24);
  tmp_0021 <= synthesier_scala_tmp_0;
  tmp_0022 <= tmp_0021(24 - 1 downto 0);
  tmp_0023 <= (24-1 downto 0 => '0') & synthesier_scala_tmp_0(63 downto 24);
  tmp_0024 <= fifo64_din_sig;
  tmp_0025 <= tmp_0024(16 - 1 downto 0);
  tmp_0026 <= synthesier_scala_tmp_0;
  tmp_0027 <= tmp_0026(8 - 1 downto 0);
  tmp_0028 <= tmp_0025 & std_logic_vector(tmp_0027);
  tmp_0029 <= (16-1 downto 0 => '0') & fifo64_din_sig(63 downto 16);
  tmp_0030 <= tmp_0029(48 - 1 downto 0);
  tmp_0031 <= (64-1 downto 48 => '0') & tmp_0030;
  tmp_0032 <= synthesier_scala_tmp_0;
  tmp_0033 <= tmp_0032(24 - 1 downto 0);
  tmp_0034 <= (24-1 downto 0 => '0') & synthesier_scala_tmp_0(63 downto 24);
  tmp_0035 <= synthesier_scala_tmp_0;
  tmp_0036 <= tmp_0035(24 - 1 downto 0);
  tmp_0037 <= not fifo24_full_sig;
  tmp_0038 <= '1' when signed(fifo64_rd_count_sig) > 100 else '0';
  tmp_0039 <= tmp_0037 and tmp_0038;

  -- sequencers
  process (clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        main <= main_IDLE;
        main_delay <= (others => '0');
      else
        case (main) is
          when main_IDLE => 
            if tmp_0001 = '1' then
              main <= main_S_0;
            end if;
          when main_S_0 => 
            main <= main_S_1;
          when main_S_1 => 
            main <= main_S_2;
          when main_S_2 => 
            main <= main_S_3;
          when main_S_3 => 
            main <= main_S_4;
          when main_S_4 => 
            main <= main_S_5;
          when main_S_5 => 
            main <= main_S_6;
          when main_S_6 => 
            main <= main_S_7;
          when main_S_7 => 
            main <= main_S_8;
          when main_S_8 => 
            main <= main_S_9;
          when main_S_9 => 
            main <= main_S_10;
          when main_S_10 => 
            main <= main_S_11;
          when main_S_11 => 
            if tmp_0039 = '1' then
              main <= main_S_3;
            end if;
          when others => null;
        end case;
      end if;
    end if;
  end process;


  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        synthesier_scala_tmp_0 <= (others => '0');
      else
        if main = main_S_3 then
          synthesier_scala_tmp_0 <= signed(tmp_0006);
        elsif main = main_S_4 then
          synthesier_scala_tmp_0 <= tmp_0009;
        elsif main = main_S_5 then
          synthesier_scala_tmp_0 <= signed(tmp_0017);
        elsif main = main_S_6 then
          synthesier_scala_tmp_0 <= tmp_0020;
        elsif main = main_S_7 then
          synthesier_scala_tmp_0 <= tmp_0023;
        elsif main = main_S_8 then
          synthesier_scala_tmp_0 <= signed(tmp_0031);
        elsif main = main_S_9 then
          synthesier_scala_tmp_0 <= tmp_0034;
        end if;
      end if;
    end if;
  end process;



end RTL;
