library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity sync_generator is
  port (
    clk : in std_logic;
    reset : in std_logic;
    VSYNC : out std_logic;
    HSYNC : out std_logic;
    DE : out std_logic;
    DATA : out std_logic_vector(24-1 downto 0);
    fifo_rd : out std_logic;
    fifo_din : in std_logic_vector(24-1 downto 0);
    wakeup : in std_logic
  );
end sync_generator;

architecture RTL of sync_generator is


  signal clk_sig : std_logic;
  signal reset_sig : std_logic;
  signal VSYNC_sig : std_logic;
  signal HSYNC_sig : std_logic;
  signal DE_sig : std_logic;
  signal DATA_sig : std_logic_vector(24-1 downto 0) := (others => '0');
  signal fifo_rd_sig : std_logic := '0';
  signal fifo_din_sig : std_logic_vector(24-1 downto 0);
  signal wakeup_sig : std_logic;

  signal hsync_counter : signed(32-1 downto 0) := (others => '0');
  signal vsync_counter : signed(32-1 downto 0) := (others => '0');
  type Type_main is (
    main_IDLE,
    main_S_0  
  );
  signal main : Type_main := main_IDLE;
  signal main_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0001 : std_logic;
  signal tmp_0002 : signed(32-1 downto 0);
  signal tmp_0003 : signed(32-1 downto 0);
  signal synthesier_scala_tmp_0 : std_logic := '0';
  signal synthesier_scala_tmp_1 : std_logic := '0';
  signal synthesier_scala_tmp_2 : std_logic := '0';
  signal tmp_0004 : std_logic;
  signal tmp_0005 : std_logic;
  signal tmp_0006 : std_logic;
  signal tmp_0007 : std_logic;
  signal tmp_0008 : std_logic;
  signal tmp_0009 : std_logic;
  signal tmp_0010 : std_logic;
  signal tmp_0011 : signed(32-1 downto 0);
  signal tmp_0012 : signed(32-1 downto 0);
  signal tmp_0013 : signed(32-1 downto 0);
  signal synthesier_scala_tmp_3 : std_logic := '0';
  signal synthesier_scala_tmp_4 : std_logic := '0';
  signal tmp_0014 : std_logic;
  signal tmp_0015 : std_logic;
  signal tmp_0016 : std_logic;
  signal tmp_0017 : std_logic;
  signal tmp_0018 : std_logic;
  signal tmp_0019 : std_logic;
  signal tmp_0020 : std_logic;
  signal tmp_0021 : std_logic;
  signal synthesier_scala_tmp_5 : std_logic;
  signal tmp_0022 : std_logic;
  signal tmp_0023 : std_logic;
  signal synthesier_scala_tmp_6 : std_logic := '0';
  signal synthesier_scala_tmp_7 : std_logic := '0';
  signal synthesier_scala_tmp_8 : std_logic := '0';
  signal tmp_0024 : std_logic;
  signal tmp_0025 : std_logic;
  signal tmp_0026 : std_logic;
  signal tmp_0027 : std_logic;
  signal tmp_0028 : std_logic;
  signal tmp_0029 : std_logic;
  signal tmp_0030 : std_logic;
  signal tmp_0031 : std_logic;
  signal tmp_0032 : std_logic;
  signal tmp_0033 : std_logic;
  signal tmp_0034 : std_logic;
  signal tmp_0035 : std_logic;
  signal tmp_0036 : std_logic;
  signal tmp_0037 : std_logic;

begin

  clk_sig <= clk;
  reset_sig <= reset;
  VSYNC <= VSYNC_sig;
  VSYNC_sig <= tmp_0036;

  HSYNC <= HSYNC_sig;
  HSYNC_sig <= tmp_0037;

  DE <= DE_sig;
  DE_sig <= synthesier_scala_tmp_5;

  DATA <= DATA_sig;
  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        DATA_sig <= (others => '0');
      else
        if main = main_S_0 then
          DATA_sig <= fifo_din_sig;
        end if;
      end if;
    end if;
  end process;

  fifo_rd <= fifo_rd_sig;
  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        fifo_rd_sig <= '0';
      else
        if main = main_S_0 then
          fifo_rd_sig <= tmp_0035;
        end if;
      end if;
    end if;
  end process;

  fifo_din_sig <= fifo_din;
  wakeup_sig <= wakeup;

  -- expressions
  tmp_0001 <= '1' when hsync_counter = 2199 else '0';
  tmp_0002 <= hsync_counter + 1;
  tmp_0003 <= (others => '0') when tmp_0001 = '1' else tmp_0002;
  tmp_0004 <= '1' when hsync_counter = 2199 else '0';
  tmp_0005 <= '1' when hsync_counter = 43 else '0';
  tmp_0006 <= '1' when tmp_0005 = '1' else synthesier_scala_tmp_0;
  tmp_0007 <= '0' when tmp_0004 = '1' else tmp_0006;
  tmp_0008 <= not synthesier_scala_tmp_0;
  tmp_0009 <= synthesier_scala_tmp_1 and tmp_0008;
  tmp_0010 <= '1' when vsync_counter = 1125 else '0';
  tmp_0011 <= vsync_counter + 1;
  tmp_0012 <= tmp_0011 when synthesier_scala_tmp_2 = '1' else vsync_counter;
  tmp_0013 <= (others => '0') when tmp_0010 = '1' else tmp_0012;
  tmp_0014 <= '1' when vsync_counter = 1121 else '0';
  tmp_0015 <= '1' when vsync_counter = 41 else '0';
  tmp_0016 <= '1' when tmp_0015 = '1' else synthesier_scala_tmp_3;
  tmp_0017 <= '0' when tmp_0014 = '1' else tmp_0016;
  tmp_0018 <= '1' when hsync_counter = 2111 else '0';
  tmp_0019 <= '1' when hsync_counter = 191 else '0';
  tmp_0020 <= '1' when tmp_0019 = '1' else synthesier_scala_tmp_4;
  tmp_0021 <= '0' when tmp_0018 = '1' else tmp_0020;
  tmp_0022 <= '1' when synthesier_scala_tmp_3 = '1' else '0';
  tmp_0023 <= synthesier_scala_tmp_4 when tmp_0022 = '1' else '0';
  tmp_0024 <= '1' when vsync_counter = 1125 else '0';
  tmp_0025 <= '1' when vsync_counter = 5 else '0';
  tmp_0026 <= '1' when tmp_0025 = '1' else synthesier_scala_tmp_6;
  tmp_0027 <= '0' when tmp_0024 = '1' else tmp_0026;
  tmp_0028 <= '1' when hsync_counter = 189 else '0';
  tmp_0029 <= '1' when vsync_counter >= 41 else '0';
  tmp_0030 <= '1' when vsync_counter < 1121 else '0';
  tmp_0031 <= tmp_0029 and tmp_0030;
  tmp_0032 <= tmp_0028 and tmp_0031;
  tmp_0033 <= '1' when hsync_counter = 2109 else '0';
  tmp_0034 <= '1' when tmp_0032 = '1' else fifo_rd_sig;
  tmp_0035 <= '0' when tmp_0033 = '1' else tmp_0034;
  tmp_0036 <= not synthesier_scala_tmp_8;
  tmp_0037 <= not synthesier_scala_tmp_0;

  -- sequencers
  process (clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        main <= main_IDLE;
        main_delay <= (others => '0');
      else
        case (main) is
          when main_IDLE => 
            if wakeup_sig = '1' then
              main <= main_S_0;
            end if;
          when main_S_0 => 
            null;
          when others => null;
        end case;
      end if;
    end if;
  end process;


  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        hsync_counter <= (others => '0');
      else
        if main = main_S_0 then
          hsync_counter <= tmp_0003;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        vsync_counter <= (others => '0');
      else
        if main = main_S_0 then
          vsync_counter <= tmp_0013;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        synthesier_scala_tmp_0 <= '0';
      else
        if main = main_S_0 then
          synthesier_scala_tmp_0 <= tmp_0007;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        synthesier_scala_tmp_1 <= '0';
      else
        if main = main_S_0 then
          synthesier_scala_tmp_1 <= synthesier_scala_tmp_0;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        synthesier_scala_tmp_2 <= '0';
      else
        if main = main_S_0 then
          synthesier_scala_tmp_2 <= tmp_0009;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        synthesier_scala_tmp_3 <= '0';
      else
        if main = main_S_0 then
          synthesier_scala_tmp_3 <= tmp_0017;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        synthesier_scala_tmp_4 <= '0';
      else
        if main = main_S_0 then
          synthesier_scala_tmp_4 <= tmp_0021;
        end if;
      end if;
    end if;
  end process;

  synthesier_scala_tmp_5 <= tmp_0023;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        synthesier_scala_tmp_6 <= '0';
      else
        if main = main_S_0 then
          synthesier_scala_tmp_6 <= tmp_0027;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        synthesier_scala_tmp_7 <= '0';
      else
        if main = main_S_0 then
          synthesier_scala_tmp_7 <= synthesier_scala_tmp_6;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        synthesier_scala_tmp_8 <= '0';
      else
        if main = main_S_0 then
          synthesier_scala_tmp_8 <= synthesier_scala_tmp_7;
        end if;
      end if;
    end if;
  end process;



end RTL;
