library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity RGBTest is
  port (
    clk : in std_logic;
    reset : in std_logic;
    obj_obj_obj_forbid : in std_logic;
    obj_obj_obj_axi_reader_ARADDR : out std_logic_vector(32-1 downto 0);
    obj_obj_obj_axi_reader_ARLEN : out std_logic_vector(8-1 downto 0);
    obj_obj_obj_axi_reader_ARVALID : out std_logic;
    obj_obj_obj_axi_reader_ARREADY : in std_logic;
    obj_obj_obj_axi_reader_ARSIZE : out std_logic_vector(3-1 downto 0);
    obj_obj_obj_axi_reader_ARBURST : out std_logic_vector(2-1 downto 0);
    obj_obj_obj_axi_reader_ARCACHE : out std_logic_vector(4-1 downto 0);
    obj_obj_obj_axi_reader_ARPROT : out std_logic_vector(3-1 downto 0);
    obj_obj_obj_axi_reader_RDATA : in std_logic_vector(32-1 downto 0);
    obj_obj_obj_axi_reader_RRESP : in std_logic_vector(2-1 downto 0);
    obj_obj_obj_axi_reader_RLAST : in std_logic;
    obj_obj_obj_axi_reader_RVALID : in std_logic;
    obj_obj_obj_axi_reader_RREADY : out std_logic;
    obj_obj_obj_axi_writer_AWADDR : out std_logic_vector(32-1 downto 0);
    obj_obj_obj_axi_writer_AWLEN : out std_logic_vector(8-1 downto 0);
    obj_obj_obj_axi_writer_AWVALID : out std_logic;
    obj_obj_obj_axi_writer_AWSIZE : out std_logic_vector(3-1 downto 0);
    obj_obj_obj_axi_writer_AWBURST : out std_logic_vector(2-1 downto 0);
    obj_obj_obj_axi_writer_AWCACHE : out std_logic_vector(4-1 downto 0);
    obj_obj_obj_axi_writer_AWPROT : out std_logic_vector(3-1 downto 0);
    obj_obj_obj_axi_writer_AWREADY : in std_logic;
    obj_obj_obj_axi_writer_WDATA : out std_logic_vector(32-1 downto 0);
    obj_obj_obj_axi_writer_WLAST : out std_logic;
    obj_obj_obj_axi_writer_WVALID : out std_logic;
    obj_obj_obj_axi_writer_WREADY : in std_logic;
    obj_obj_obj_axi_writer_WSTRB : out std_logic_vector(4-1 downto 0);
    obj_obj_obj_axi_writer_BRESP : in std_logic_vector(2-1 downto 0);
    obj_obj_obj_axi_writer_BVALID : in std_logic;
    obj_obj_obj_axi_writer_BREADY : out std_logic;
    run_req : in std_logic;
    run_busy : out std_logic
  );
end RGBTest;

architecture RTL of RGBTest is

  component sintable_rom
    port (
      clk : in std_logic;
      reset : in std_logic;
      sintable_address : in std_logic_vector(32-1 downto 0);
      sintable_din : in std_logic_vector(32-1 downto 0);
      sintable_dout : out std_logic_vector(32-1 downto 0);
      sintable_length : out std_logic_vector(32-1 downto 0);
      sintable_we : in std_logic;
      sintable_oe : in std_logic
    );
  end component sintable_rom;
  component dualportram
    generic (
      WIDTH : integer := 32;
      DEPTH : integer := 10;
      WORDS : integer := 1024
    );
    port (
      clk : in std_logic;
      reset : in std_logic;
      length : out signed(32-1 downto 0);
      address : in signed(32-1 downto 0);
      din : in signed(32-1 downto 0);
      dout : out signed(32-1 downto 0);
      we : in std_logic;
      oe : in std_logic;
      address_b : in signed(32-1 downto 0);
      din_b : in signed(32-1 downto 0);
      dout_b : out signed(32-1 downto 0);
      we_b : in std_logic;
      oe_b : in std_logic
    );
  end component dualportram;
  component TestFrame
    port (
      clk : in std_logic;
      reset : in std_logic;
      obj_obj_forbid : in std_logic;
      obj_obj_axi_reader_ARADDR : out std_logic_vector(32-1 downto 0);
      obj_obj_axi_reader_ARLEN : out std_logic_vector(8-1 downto 0);
      obj_obj_axi_reader_ARVALID : out std_logic;
      obj_obj_axi_reader_ARREADY : in std_logic;
      obj_obj_axi_reader_ARSIZE : out std_logic_vector(3-1 downto 0);
      obj_obj_axi_reader_ARBURST : out std_logic_vector(2-1 downto 0);
      obj_obj_axi_reader_ARCACHE : out std_logic_vector(4-1 downto 0);
      obj_obj_axi_reader_ARPROT : out std_logic_vector(3-1 downto 0);
      obj_obj_axi_reader_RDATA : in std_logic_vector(32-1 downto 0);
      obj_obj_axi_reader_RRESP : in std_logic_vector(2-1 downto 0);
      obj_obj_axi_reader_RLAST : in std_logic;
      obj_obj_axi_reader_RVALID : in std_logic;
      obj_obj_axi_reader_RREADY : out std_logic;
      obj_obj_axi_writer_AWADDR : out std_logic_vector(32-1 downto 0);
      obj_obj_axi_writer_AWLEN : out std_logic_vector(8-1 downto 0);
      obj_obj_axi_writer_AWVALID : out std_logic;
      obj_obj_axi_writer_AWSIZE : out std_logic_vector(3-1 downto 0);
      obj_obj_axi_writer_AWBURST : out std_logic_vector(2-1 downto 0);
      obj_obj_axi_writer_AWCACHE : out std_logic_vector(4-1 downto 0);
      obj_obj_axi_writer_AWPROT : out std_logic_vector(3-1 downto 0);
      obj_obj_axi_writer_AWREADY : in std_logic;
      obj_obj_axi_writer_WDATA : out std_logic_vector(32-1 downto 0);
      obj_obj_axi_writer_WLAST : out std_logic;
      obj_obj_axi_writer_WVALID : out std_logic;
      obj_obj_axi_writer_WREADY : in std_logic;
      obj_obj_axi_writer_WSTRB : out std_logic_vector(4-1 downto 0);
      obj_obj_axi_writer_BRESP : in std_logic_vector(2-1 downto 0);
      obj_obj_axi_writer_BVALID : in std_logic;
      obj_obj_axi_writer_BREADY : out std_logic;
      pset_x_in : in signed(32-1 downto 0);
      pset_y_in : in signed(32-1 downto 0);
      pset_color_in : in signed(32-1 downto 0);
      pset_req : in std_logic;
      pset_busy : out std_logic;
      clear_req : in std_logic;
      clear_busy : out std_logic;
      fill_rect_x_in : in signed(32-1 downto 0);
      fill_rect_y_in : in signed(32-1 downto 0);
      fill_rect_w_in : in signed(32-1 downto 0);
      fill_rect_h_in : in signed(32-1 downto 0);
      fill_rect_c_in : in signed(32-1 downto 0);
      fill_rect_req : in std_logic;
      fill_rect_busy : out std_logic;
      test_req : in std_logic;
      test_busy : out std_logic;
      flush_req : in std_logic;
      flush_busy : out std_logic
    );
  end component TestFrame;

  signal clk_sig : std_logic;
  signal reset_sig : std_logic;
  signal run_req_sig : std_logic;
  signal run_busy_sig : std_logic;

  signal sin_clk : std_logic;
  signal sin_reset : std_logic;
  signal sin_sintable_address : std_logic_vector(32-1 downto 0) := (others => '0');
  signal sin_sintable_din : std_logic_vector(32-1 downto 0) := (others => '0');
  signal sin_sintable_dout : std_logic_vector(32-1 downto 0);
  signal sin_sintable_length : std_logic_vector(32-1 downto 0);
  signal sin_sintable_we : std_logic := '0';
  signal sin_sintable_oe : std_logic := '0';
  signal colortbl_clk : std_logic;
  signal colortbl_reset : std_logic;
  signal colortbl_length : signed(32-1 downto 0);
  signal colortbl_address : signed(32-1 downto 0) := (others => '0');
  signal colortbl_din : signed(32-1 downto 0) := (others => '0');
  signal colortbl_dout : signed(32-1 downto 0);
  signal colortbl_we : std_logic := '0';
  signal colortbl_oe : std_logic := '0';
  signal colortbl_address_b : signed(32-1 downto 0) := (others => '0');
  signal colortbl_din_b : signed(32-1 downto 0) := (others => '0');
  signal colortbl_dout_b : signed(32-1 downto 0);
  signal colortbl_we_b : std_logic := '0';
  signal colortbl_oe_b : std_logic := '0';
  signal obj_clk : std_logic;
  signal obj_reset : std_logic;
  signal obj_pset_x_in : signed(32-1 downto 0) := (others => '0');
  signal obj_pset_y_in : signed(32-1 downto 0) := (others => '0');
  signal obj_pset_color_in : signed(32-1 downto 0) := (others => '0');
  signal obj_pset_req : std_logic := '0';
  signal obj_pset_busy : std_logic;
  signal obj_clear_req : std_logic := '0';
  signal obj_clear_busy : std_logic;
  signal obj_fill_rect_x_in : signed(32-1 downto 0) := (others => '0');
  signal obj_fill_rect_y_in : signed(32-1 downto 0) := (others => '0');
  signal obj_fill_rect_w_in : signed(32-1 downto 0) := (others => '0');
  signal obj_fill_rect_h_in : signed(32-1 downto 0) := (others => '0');
  signal obj_fill_rect_c_in : signed(32-1 downto 0) := (others => '0');
  signal obj_fill_rect_req : std_logic := '0';
  signal obj_fill_rect_busy : std_logic;
  signal obj_test_req : std_logic := '0';
  signal obj_test_busy : std_logic;
  signal obj_flush_req : std_logic := '0';
  signal obj_flush_busy : std_logic;
  signal paint_sincurve_x_4 : signed(32-1 downto 0) := (others => '0');
  signal paint_sincurve_i_5 : signed(32-1 downto 0) := X"00000000";
  signal paint_sincurve_c_2 : signed(32-1 downto 0) := (others => '0');
  signal paint_sincurve_y_3 : signed(32-1 downto 0) := (others => '0');
  signal sleep_i_1 : signed(32-1 downto 0) := X"00000000";
  type Type_methodId is (
    IDLE,
    method_init_colortbl,
    method_paint_sincurve,
    method_sleep,
    method_run,
    method_main  
  );
  signal methodId : Type_methodId := IDLE;
  signal init_colortbl_req_local : std_logic := '0';
  signal tmp_0001 : std_logic;
  signal init_colortbl_busy_sig : std_logic;
  type Type_S_init_colortbl is (
    S_init_colortbl_IDLE,
    S_init_colortbl_S_init_colortbl_0001,
    S_init_colortbl_S_init_colortbl_0002,
    S_init_colortbl_S_init_colortbl_0003,
    S_init_colortbl_S_init_colortbl_0004,
    S_init_colortbl_S_init_colortbl_0005,
    S_init_colortbl_S_init_colortbl_0006,
    S_init_colortbl_S_init_colortbl_0007  
  );
  signal S_init_colortbl : Type_S_init_colortbl := S_init_colortbl_IDLE;
  signal S_init_colortbl_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0002 : std_logic;
  signal tmp_0003 : std_logic;
  signal tmp_0004 : signed(32-1 downto 0);
  signal tmp_0005 : signed(32-1 downto 0);
  signal tmp_0006 : signed(32-1 downto 0);
  signal tmp_0007 : signed(32-1 downto 0);
  signal tmp_0008 : signed(32-1 downto 0);
  signal tmp_0009 : signed(32-1 downto 0);
  signal tmp_0010 : signed(32-1 downto 0);
  signal tmp_0011 : signed(32-1 downto 0);
  signal tmp_0012 : signed(32-1 downto 0);
  signal tmp_0013 : signed(32-1 downto 0);
  signal tmp_0014 : signed(32-1 downto 0);
  signal tmp_0015 : signed(32-1 downto 0);
  signal paint_sincurve_offset : signed(32-1 downto 0) := (others => '0');
  signal paint_sincurve_req_local : std_logic := '0';
  signal tmp_0016 : std_logic;
  signal paint_sincurve_busy_sig : std_logic;
  signal paint_sincurve_c_id_1 : signed(32-1 downto 0) := X"00000000";
  type Type_S_paint_sincurve is (
    S_paint_sincurve_IDLE,
    S_paint_sincurve_S_paint_sincurve_0001,
    S_paint_sincurve_S_paint_sincurve_0002,
    S_paint_sincurve_S_paint_sincurve_0003,
    S_paint_sincurve_S_paint_sincurve_0004,
    S_paint_sincurve_S_paint_sincurve_0005,
    S_paint_sincurve_S_paint_sincurve_0006,
    S_paint_sincurve_S_paint_sincurve_0007,
    S_paint_sincurve_S_paint_sincurve_0008,
    S_paint_sincurve_S_paint_sincurve_0009,
    S_paint_sincurve_S_paint_sincurve_0010,
    S_paint_sincurve_S_paint_sincurve_0012  
  );
  signal S_paint_sincurve : Type_S_paint_sincurve := S_paint_sincurve_IDLE;
  signal S_paint_sincurve_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0017 : signed(32-1 downto 0);
  signal tmp_0018 : signed(32-1 downto 0);
  signal tmp_0019 : signed(32-1 downto 0);
  signal tmp_0020 : std_logic;
  signal tmp_0021 : std_logic;
  signal tmp_0022 : signed(32-1 downto 0);
  signal tmp_0023 : signed(32-1 downto 0);
  signal tmp_0024 : signed(32-1 downto 0);
  signal tmp_0025 : std_logic;
  signal tmp_0026 : std_logic;
  signal tmp_0027 : signed(32-1 downto 0);
  signal tmp_0028 : std_logic;
  signal tmp_0029 : std_logic;
  signal tmp_0030 : signed(32-1 downto 0);
  signal tmp_0031 : std_logic;
  signal tmp_0032 : std_logic;
  signal tmp_0033 : std_logic;
  signal tmp_0034 : std_logic;
  signal tmp_0035 : signed(32-1 downto 0);
  signal tmp_0036 : signed(32-1 downto 0);
  signal tmp_0037 : signed(32-1 downto 0);
  signal tmp_0038 : signed(32-1 downto 0);
  signal tmp_0039 : signed(32-1 downto 0);
  signal tmp_0040 : signed(32-1 downto 0);
  signal tmp_0041 : signed(32-1 downto 0);
  signal tmp_0042 : signed(32-1 downto 0);
  signal tmp_0043 : signed(32-1 downto 0);
  signal obj_fill_rect_busy_0044 : std_logic;
  signal tmp_0045 : std_logic;
  signal tmp_0046 : std_logic;
  signal tmp_0047 : std_logic;
  signal tmp_0048 : std_logic;
  signal tmp_0049 : signed(32-1 downto 0);
  signal tmp_0050 : signed(32-1 downto 0);
  signal tmp_0051 : signed(32-1 downto 0);
  signal tmp_0052 : signed(32-1 downto 0);
  signal sleep_n : signed(32-1 downto 0) := (others => '0');
  signal sleep_req_local : std_logic := '0';
  signal tmp_0053 : std_logic;
  signal sleep_busy_sig : std_logic;
  type Type_S_sleep is (
    S_sleep_IDLE,
    S_sleep_S_sleep_0001,
    S_sleep_S_sleep_0002,
    S_sleep_S_sleep_0003,
    S_sleep_S_sleep_0004  
  );
  signal S_sleep : Type_S_sleep := S_sleep_IDLE;
  signal S_sleep_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0054 : std_logic;
  signal tmp_0055 : std_logic;
  signal tmp_0056 : std_logic;
  signal tmp_0057 : std_logic;
  signal tmp_0058 : std_logic;
  signal tmp_0059 : std_logic;
  signal tmp_0060 : signed(32-1 downto 0);
  signal tmp_0061 : signed(32-1 downto 0);
  signal run_req_local : std_logic := '0';
  signal tmp_0062 : std_logic;
  type Type_S_run is (
    S_run_IDLE,
    S_run_S_run_0001,
    S_run_S_run_0002,
    S_run_S_run_0003,
    S_run_S_run_0004,
    S_run_S_run_0005,
    S_run_S_run_0006,
    S_run_S_run_0007,
    S_run_S_run_0008,
    S_run_S_run_0009  
  );
  signal S_run : Type_S_run := S_run_IDLE;
  signal S_run_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0063 : std_logic;
  signal tmp_0064 : std_logic;
  signal tmp_0065 : std_logic;
  signal tmp_0066 : std_logic;
  signal tmp_0067 : std_logic;
  signal tmp_0068 : std_logic;
  signal init_colortbl_busy_sig_0069 : std_logic;
  signal tmp_0070 : std_logic;
  signal tmp_0071 : std_logic;
  signal tmp_0072 : std_logic;
  signal tmp_0073 : std_logic;
  signal tmp_0074 : signed(32-1 downto 0);
  signal paint_sincurve_busy_sig_0075 : std_logic;
  signal tmp_0076 : std_logic;
  signal tmp_0077 : std_logic;
  signal tmp_0078 : std_logic;
  signal tmp_0079 : std_logic;
  signal tmp_0080 : signed(32-1 downto 0);
  signal paint_sincurve_busy_sig_0081 : std_logic;
  signal tmp_0082 : std_logic;
  signal tmp_0083 : std_logic;
  signal tmp_0084 : std_logic;
  signal tmp_0085 : std_logic;
  signal tmp_0086 : signed(32-1 downto 0);
  signal paint_sincurve_busy_sig_0087 : std_logic;
  signal tmp_0088 : std_logic;
  signal tmp_0089 : std_logic;
  signal tmp_0090 : std_logic;
  signal tmp_0091 : std_logic;
  signal tmp_0092 : signed(32-1 downto 0);
  signal paint_sincurve_busy_sig_0093 : std_logic;
  signal tmp_0094 : std_logic;
  signal tmp_0095 : std_logic;
  signal tmp_0096 : std_logic;
  signal tmp_0097 : std_logic;
  signal tmp_0098 : signed(32-1 downto 0);
  signal sleep_busy_sig_0099 : std_logic;
  signal tmp_0100 : std_logic;
  signal tmp_0101 : std_logic;
  signal tmp_0102 : std_logic;
  signal tmp_0103 : std_logic;
  signal obj_flush_busy_0104 : std_logic;
  signal tmp_0105 : std_logic;
  signal tmp_0106 : std_logic;
  signal tmp_0107 : std_logic;
  signal tmp_0108 : std_logic;

begin

  clk_sig <= clk;
  reset_sig <= reset;
  run_req_sig <= run_req;
  run_busy <= run_busy_sig;
  run_busy_sig <= tmp_0068;


  -- expressions
  tmp_0001 <= '1' when init_colortbl_req_local = '1' else '0';
  tmp_0002 <= '1' when S_init_colortbl = S_init_colortbl_IDLE else '0';
  tmp_0003 <= '0' when tmp_0002 = '1' else '1';
  tmp_0004 <= X"00ff0000";
  tmp_0005 <= X"00000000";
  tmp_0006 <= X"00ffff00";
  tmp_0007 <= X"00000001";
  tmp_0008 <= X"0000ff00";
  tmp_0009 <= X"00000002";
  tmp_0010 <= X"0000ffff";
  tmp_0011 <= X"00000003";
  tmp_0012 <= X"000000ff";
  tmp_0013 <= X"00000004";
  tmp_0014 <= X"00ff00ff";
  tmp_0015 <= X"00000005";
  tmp_0016 <= '1' when paint_sincurve_req_local = '1' else '0';
  tmp_0017 <= X"00000780";
  tmp_0018 <= X"00000002";
  tmp_0019 <= (2-1 downto 0 => tmp_0017(31)) & tmp_0017(31 downto 2);
  tmp_0020 <= '1' when paint_sincurve_i_5 < tmp_0019 else '0';
  tmp_0021 <= '1' when tmp_0020 = '0' else '0';
  tmp_0022 <= X"00000780";
  tmp_0023 <= X"00000002";
  tmp_0024 <= (2-1 downto 0 => tmp_0022(31)) & tmp_0022(31 downto 2);
  tmp_0025 <= '1' when paint_sincurve_i_5 < tmp_0024 else '0';
  tmp_0026 <= '1' when tmp_0025 = '1' else '0';
  tmp_0027 <= X"00000006";
  tmp_0028 <= '1' when paint_sincurve_c_id_1 = tmp_0027 else '0';
  tmp_0029 <= '1' when tmp_0028 = '1' else '0';
  tmp_0030 <= X"00000006";
  tmp_0031 <= '1' when paint_sincurve_c_id_1 = tmp_0030 else '0';
  tmp_0032 <= '1' when tmp_0031 = '0' else '0';
  tmp_0033 <= '1' when S_paint_sincurve = S_paint_sincurve_IDLE else '0';
  tmp_0034 <= '0' when tmp_0033 = '1' else '1';
  tmp_0035 <= X"00000000";
  tmp_0036 <= X"00000000";
  tmp_0037 <= X"00000002";
  tmp_0038 <= paint_sincurve_i_5(29 downto 0) & (2-1 downto 0 => '0');
  tmp_0039 <= paint_sincurve_i_5 + paint_sincurve_offset;
  tmp_0040 <= X"0000007f";
  tmp_0041 <= tmp_0039 and tmp_0040;
  tmp_0042 <= X"00000004";
  tmp_0043 <= X"00000004";
  tmp_0045 <= '1' when obj_fill_rect_busy = '0' else '0';
  tmp_0046 <= '1' when obj_fill_rect_req = '0' else '0';
  tmp_0047 <= tmp_0045 and tmp_0046;
  tmp_0048 <= '1' when tmp_0047 = '1' else '0';
  tmp_0049 <= X"00000001";
  tmp_0050 <= paint_sincurve_c_id_1 + tmp_0049;
  tmp_0051 <= X"00000000";
  tmp_0052 <= paint_sincurve_i_5 + 1;
  tmp_0053 <= '1' when sleep_req_local = '1' else '0';
  tmp_0054 <= '1' when sleep_i_1 < sleep_n else '0';
  tmp_0055 <= '1' when tmp_0054 = '0' else '0';
  tmp_0056 <= '1' when sleep_i_1 < sleep_n else '0';
  tmp_0057 <= '1' when tmp_0056 = '1' else '0';
  tmp_0058 <= '1' when S_sleep = S_sleep_IDLE else '0';
  tmp_0059 <= '0' when tmp_0058 = '1' else '1';
  tmp_0060 <= X"00000000";
  tmp_0061 <= sleep_i_1 + 1;
  tmp_0062 <= run_req_sig or run_req_local;
  tmp_0063 <= '1';
  tmp_0064 <= '1' when tmp_0063 = '1' else '0';
  tmp_0065 <= '1';
  tmp_0066 <= '1' when tmp_0065 = '0' else '0';
  tmp_0067 <= '1' when S_run = S_run_IDLE else '0';
  tmp_0068 <= '0' when tmp_0067 = '1' else '1';
  tmp_0070 <= '1' when init_colortbl_busy_sig = '0' else '0';
  tmp_0071 <= '1' when init_colortbl_req_local = '0' else '0';
  tmp_0072 <= tmp_0070 and tmp_0071;
  tmp_0073 <= '1' when tmp_0072 = '1' else '0';
  tmp_0074 <= X"00000000";
  tmp_0076 <= '1' when paint_sincurve_busy_sig = '0' else '0';
  tmp_0077 <= '1' when paint_sincurve_req_local = '0' else '0';
  tmp_0078 <= tmp_0076 and tmp_0077;
  tmp_0079 <= '1' when tmp_0078 = '1' else '0';
  tmp_0080 <= X"00000020";
  tmp_0082 <= '1' when paint_sincurve_busy_sig = '0' else '0';
  tmp_0083 <= '1' when paint_sincurve_req_local = '0' else '0';
  tmp_0084 <= tmp_0082 and tmp_0083;
  tmp_0085 <= '1' when tmp_0084 = '1' else '0';
  tmp_0086 <= X"00000040";
  tmp_0088 <= '1' when paint_sincurve_busy_sig = '0' else '0';
  tmp_0089 <= '1' when paint_sincurve_req_local = '0' else '0';
  tmp_0090 <= tmp_0088 and tmp_0089;
  tmp_0091 <= '1' when tmp_0090 = '1' else '0';
  tmp_0092 <= X"00000060";
  tmp_0094 <= '1' when paint_sincurve_busy_sig = '0' else '0';
  tmp_0095 <= '1' when paint_sincurve_req_local = '0' else '0';
  tmp_0096 <= tmp_0094 and tmp_0095;
  tmp_0097 <= '1' when tmp_0096 = '1' else '0';
  tmp_0098 <= X"00000064";
  tmp_0100 <= '1' when sleep_busy_sig = '0' else '0';
  tmp_0101 <= '1' when sleep_req_local = '0' else '0';
  tmp_0102 <= tmp_0100 and tmp_0101;
  tmp_0103 <= '1' when tmp_0102 = '1' else '0';
  tmp_0105 <= '1' when obj_flush_busy = '0' else '0';
  tmp_0106 <= '1' when obj_flush_req = '0' else '0';
  tmp_0107 <= tmp_0105 and tmp_0106;
  tmp_0108 <= '1' when tmp_0107 = '1' else '0';

  -- sequencers
  process (clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        S_init_colortbl <= S_init_colortbl_IDLE;
        S_init_colortbl_delay <= (others => '0');
      else
        case (S_init_colortbl) is
          when S_init_colortbl_IDLE => 
            if tmp_0001 = '1' then
              S_init_colortbl <= S_init_colortbl_S_init_colortbl_0007;
            end if;
          when S_init_colortbl_S_init_colortbl_0001 => 
            S_init_colortbl <= S_init_colortbl_IDLE;
          when S_init_colortbl_S_init_colortbl_0002 => 
            S_init_colortbl <= S_init_colortbl_S_init_colortbl_0001;
          when S_init_colortbl_S_init_colortbl_0003 => 
            S_init_colortbl <= S_init_colortbl_S_init_colortbl_0002;
          when S_init_colortbl_S_init_colortbl_0004 => 
            S_init_colortbl <= S_init_colortbl_S_init_colortbl_0003;
          when S_init_colortbl_S_init_colortbl_0005 => 
            S_init_colortbl <= S_init_colortbl_S_init_colortbl_0004;
          when S_init_colortbl_S_init_colortbl_0006 => 
            S_init_colortbl <= S_init_colortbl_S_init_colortbl_0005;
          when S_init_colortbl_S_init_colortbl_0007 => 
            S_init_colortbl <= S_init_colortbl_S_init_colortbl_0006;
          when others => null;
        end case;
      end if;
    end if;
  end process;

  process (clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        S_paint_sincurve <= S_paint_sincurve_IDLE;
        S_paint_sincurve_delay <= (others => '0');
      else
        case (S_paint_sincurve) is
          when S_paint_sincurve_IDLE => 
            if tmp_0016 = '1' then
              S_paint_sincurve <= S_paint_sincurve_S_paint_sincurve_0012;
            end if;
          when S_paint_sincurve_S_paint_sincurve_0001 => 
            S_paint_sincurve <= S_paint_sincurve_IDLE;
          when S_paint_sincurve_S_paint_sincurve_0002 => 
            if tmp_0021 = '1' then
              S_paint_sincurve <= S_paint_sincurve_S_paint_sincurve_0001;
            elsif tmp_0026 = '1' then
              S_paint_sincurve <= S_paint_sincurve_S_paint_sincurve_0010;
            end if;
          when S_paint_sincurve_S_paint_sincurve_0003 => 
            S_paint_sincurve <= S_paint_sincurve_S_paint_sincurve_0002;
          when S_paint_sincurve_S_paint_sincurve_0004 => 
            S_paint_sincurve <= S_paint_sincurve_S_paint_sincurve_0003;
          when S_paint_sincurve_S_paint_sincurve_0005 => 
            if tmp_0029 = '1' then
              S_paint_sincurve <= S_paint_sincurve_S_paint_sincurve_0004;
            elsif tmp_0032 = '1' then
              S_paint_sincurve <= S_paint_sincurve_S_paint_sincurve_0003;
            end if;
          when S_paint_sincurve_S_paint_sincurve_0006 => 
            S_paint_sincurve <= S_paint_sincurve_S_paint_sincurve_0005;
          when S_paint_sincurve_S_paint_sincurve_0007 => 
            if S_paint_sincurve_delay >= 1 and obj_fill_rect_busy_0044 = '1' then
              S_paint_sincurve_delay <= (others => '0');
              S_paint_sincurve <= S_paint_sincurve_S_paint_sincurve_0006;
            else
              S_paint_sincurve_delay <= S_paint_sincurve_delay + 1;
            end if;
          when S_paint_sincurve_S_paint_sincurve_0008 => 
            if S_paint_sincurve_delay >= 2 then
              S_paint_sincurve_delay <= (others => '0');
              S_paint_sincurve <= S_paint_sincurve_S_paint_sincurve_0007;
            else
              S_paint_sincurve_delay <= S_paint_sincurve_delay + 1;
            end if;
          when S_paint_sincurve_S_paint_sincurve_0009 => 
            if S_paint_sincurve_delay >= 2 then
              S_paint_sincurve_delay <= (others => '0');
              S_paint_sincurve <= S_paint_sincurve_S_paint_sincurve_0008;
            else
              S_paint_sincurve_delay <= S_paint_sincurve_delay + 1;
            end if;
          when S_paint_sincurve_S_paint_sincurve_0010 => 
            S_paint_sincurve <= S_paint_sincurve_S_paint_sincurve_0009;
          when S_paint_sincurve_S_paint_sincurve_0012 => 
            S_paint_sincurve <= S_paint_sincurve_S_paint_sincurve_0002;
          when others => null;
        end case;
      end if;
    end if;
  end process;

  process (clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        S_sleep <= S_sleep_IDLE;
        S_sleep_delay <= (others => '0');
      else
        case (S_sleep) is
          when S_sleep_IDLE => 
            if tmp_0053 = '1' then
              S_sleep <= S_sleep_S_sleep_0004;
            end if;
          when S_sleep_S_sleep_0001 => 
            S_sleep <= S_sleep_IDLE;
          when S_sleep_S_sleep_0002 => 
            if tmp_0055 = '1' then
              S_sleep <= S_sleep_S_sleep_0001;
            elsif tmp_0057 = '1' then
              S_sleep <= S_sleep_S_sleep_0003;
            end if;
          when S_sleep_S_sleep_0003 => 
            S_sleep <= S_sleep_S_sleep_0002;
          when S_sleep_S_sleep_0004 => 
            S_sleep <= S_sleep_S_sleep_0002;
          when others => null;
        end case;
      end if;
    end if;
  end process;

  process (clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        S_run <= S_run_IDLE;
        S_run_delay <= (others => '0');
      else
        case (S_run) is
          when S_run_IDLE => 
            if tmp_0062 = '1' then
              S_run <= S_run_S_run_0009;
            end if;
          when S_run_S_run_0001 => 
            S_run <= S_run_IDLE;
          when S_run_S_run_0002 => 
            if tmp_0064 = '1' then
              S_run <= S_run_S_run_0008;
            elsif tmp_0066 = '1' then
              S_run <= S_run_S_run_0001;
            end if;
          when S_run_S_run_0003 => 
            if S_run_delay >= 1 and obj_flush_busy_0104 = '1' then
              S_run_delay <= (others => '0');
              S_run <= S_run_S_run_0002;
            else
              S_run_delay <= S_run_delay + 1;
            end if;
          when S_run_S_run_0004 => 
            if S_run_delay >= 1 and sleep_busy_sig_0099 = '1' then
              S_run_delay <= (others => '0');
              S_run <= S_run_S_run_0003;
            else
              S_run_delay <= S_run_delay + 1;
            end if;
          when S_run_S_run_0005 => 
            if S_run_delay >= 1 and paint_sincurve_busy_sig_0093 = '1' then
              S_run_delay <= (others => '0');
              S_run <= S_run_S_run_0004;
            else
              S_run_delay <= S_run_delay + 1;
            end if;
          when S_run_S_run_0006 => 
            if S_run_delay >= 1 and paint_sincurve_busy_sig_0087 = '1' then
              S_run_delay <= (others => '0');
              S_run <= S_run_S_run_0005;
            else
              S_run_delay <= S_run_delay + 1;
            end if;
          when S_run_S_run_0007 => 
            if S_run_delay >= 1 and paint_sincurve_busy_sig_0081 = '1' then
              S_run_delay <= (others => '0');
              S_run <= S_run_S_run_0006;
            else
              S_run_delay <= S_run_delay + 1;
            end if;
          when S_run_S_run_0008 => 
            if S_run_delay >= 1 and paint_sincurve_busy_sig_0075 = '1' then
              S_run_delay <= (others => '0');
              S_run <= S_run_S_run_0007;
            else
              S_run_delay <= S_run_delay + 1;
            end if;
          when S_run_S_run_0009 => 
            if S_run_delay >= 1 and init_colortbl_busy_sig_0069 = '1' then
              S_run_delay <= (others => '0');
              S_run <= S_run_S_run_0002;
            else
              S_run_delay <= S_run_delay + 1;
            end if;
          when others => null;
        end case;
      end if;
    end if;
  end process;


  sin_clk <= clk_sig;

  sin_reset <= reset_sig;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        sin_sintable_address <= (others => '0');
      else
        if S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0009 and S_paint_sincurve_delay = 0 then
          sin_sintable_address <= std_logic_vector(tmp_0041);
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        sin_sintable_we <= '0';
      else
        if S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0009 and S_paint_sincurve_delay >= 2 then
          sin_sintable_we <= '0';
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        sin_sintable_oe <= '0';
      else
        if S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0009 and S_paint_sincurve_delay = 0 then
          sin_sintable_oe <= '1';
        else
          sin_sintable_oe <= '0';
        end if;
      end if;
    end if;
  end process;

  colortbl_clk <= clk_sig;

  colortbl_reset <= reset_sig;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        colortbl_address_b <= (others => '0');
      else
        if S_init_colortbl = S_init_colortbl_S_init_colortbl_0007 then
          colortbl_address_b <= tmp_0005;
        elsif S_init_colortbl = S_init_colortbl_S_init_colortbl_0006 then
          colortbl_address_b <= tmp_0007;
        elsif S_init_colortbl = S_init_colortbl_S_init_colortbl_0005 then
          colortbl_address_b <= tmp_0009;
        elsif S_init_colortbl = S_init_colortbl_S_init_colortbl_0004 then
          colortbl_address_b <= tmp_0011;
        elsif S_init_colortbl = S_init_colortbl_S_init_colortbl_0003 then
          colortbl_address_b <= tmp_0013;
        elsif S_init_colortbl = S_init_colortbl_S_init_colortbl_0002 then
          colortbl_address_b <= tmp_0015;
        elsif S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0008 and S_paint_sincurve_delay = 0 then
          colortbl_address_b <= paint_sincurve_c_id_1;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        colortbl_din_b <= (others => '0');
      else
        if S_init_colortbl = S_init_colortbl_S_init_colortbl_0007 then
          colortbl_din_b <= tmp_0004;
        elsif S_init_colortbl = S_init_colortbl_S_init_colortbl_0006 then
          colortbl_din_b <= tmp_0006;
        elsif S_init_colortbl = S_init_colortbl_S_init_colortbl_0005 then
          colortbl_din_b <= tmp_0008;
        elsif S_init_colortbl = S_init_colortbl_S_init_colortbl_0004 then
          colortbl_din_b <= tmp_0010;
        elsif S_init_colortbl = S_init_colortbl_S_init_colortbl_0003 then
          colortbl_din_b <= tmp_0012;
        elsif S_init_colortbl = S_init_colortbl_S_init_colortbl_0002 then
          colortbl_din_b <= tmp_0014;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        colortbl_we_b <= '0';
      else
        if S_init_colortbl = S_init_colortbl_S_init_colortbl_0007 then
          colortbl_we_b <= '1';
        elsif S_init_colortbl = S_init_colortbl_S_init_colortbl_0006 then
          colortbl_we_b <= '1';
        elsif S_init_colortbl = S_init_colortbl_S_init_colortbl_0005 then
          colortbl_we_b <= '1';
        elsif S_init_colortbl = S_init_colortbl_S_init_colortbl_0004 then
          colortbl_we_b <= '1';
        elsif S_init_colortbl = S_init_colortbl_S_init_colortbl_0003 then
          colortbl_we_b <= '1';
        elsif S_init_colortbl = S_init_colortbl_S_init_colortbl_0002 then
          colortbl_we_b <= '1';
        elsif S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0008 and S_paint_sincurve_delay >= 2 then
          colortbl_we_b <= '0';
        else
          colortbl_we_b <= '0';
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        colortbl_oe_b <= '0';
      else
        if S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0008 and S_paint_sincurve_delay = 0 then
          colortbl_oe_b <= '1';
        else
          colortbl_oe_b <= '0';
        end if;
      end if;
    end if;
  end process;

  obj_clk <= clk_sig;

  obj_reset <= reset_sig;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        obj_fill_rect_x_in <= (others => '0');
      else
        if S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0007 and S_paint_sincurve_delay = 0 then
          obj_fill_rect_x_in <= paint_sincurve_x_4;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        obj_fill_rect_y_in <= (others => '0');
      else
        if S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0007 and S_paint_sincurve_delay = 0 then
          obj_fill_rect_y_in <= paint_sincurve_y_3;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        obj_fill_rect_w_in <= (others => '0');
      else
        if S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0007 and S_paint_sincurve_delay = 0 then
          obj_fill_rect_w_in <= tmp_0042;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        obj_fill_rect_h_in <= (others => '0');
      else
        if S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0007 and S_paint_sincurve_delay = 0 then
          obj_fill_rect_h_in <= tmp_0043;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        obj_fill_rect_c_in <= (others => '0');
      else
        if S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0007 and S_paint_sincurve_delay = 0 then
          obj_fill_rect_c_in <= paint_sincurve_c_2;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        obj_fill_rect_req <= '0';
      else
        if S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0007 and S_paint_sincurve_delay = 0 then
          obj_fill_rect_req <= '1';
        else
          obj_fill_rect_req <= '0';
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        obj_flush_req <= '0';
      else
        if S_run = S_run_S_run_0003 and S_run_delay = 0 then
          obj_flush_req <= '1';
        else
          obj_flush_req <= '0';
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        paint_sincurve_x_4 <= (others => '0');
      else
        if S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0010 then
          paint_sincurve_x_4 <= tmp_0038;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        paint_sincurve_i_5 <= X"00000000";
      else
        if S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0012 then
          paint_sincurve_i_5 <= tmp_0036;
        elsif S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0003 then
          paint_sincurve_i_5 <= tmp_0052;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        paint_sincurve_c_2 <= (others => '0');
      else
        if S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0008 and S_paint_sincurve_delay >= 2 then
          paint_sincurve_c_2 <= colortbl_dout_b;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        paint_sincurve_y_3 <= (others => '0');
      else
        if S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0009 and S_paint_sincurve_delay >= 2 then
          paint_sincurve_y_3 <= signed(sin_sintable_dout);
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        sleep_i_1 <= X"00000000";
      else
        if S_sleep = S_sleep_S_sleep_0004 then
          sleep_i_1 <= tmp_0060;
        elsif S_sleep = S_sleep_S_sleep_0003 then
          sleep_i_1 <= tmp_0061;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        init_colortbl_req_local <= '0';
      else
        if S_run = S_run_S_run_0009 and S_run_delay = 0 then
          init_colortbl_req_local <= '1';
        else
          init_colortbl_req_local <= '0';
        end if;
      end if;
    end if;
  end process;

  init_colortbl_busy_sig <= tmp_0003;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        paint_sincurve_offset <= (others => '0');
      else
        if S_run = S_run_S_run_0008 and S_run_delay = 0 then
          paint_sincurve_offset <= tmp_0074;
        elsif S_run = S_run_S_run_0007 and S_run_delay = 0 then
          paint_sincurve_offset <= tmp_0080;
        elsif S_run = S_run_S_run_0006 and S_run_delay = 0 then
          paint_sincurve_offset <= tmp_0086;
        elsif S_run = S_run_S_run_0005 and S_run_delay = 0 then
          paint_sincurve_offset <= tmp_0092;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        paint_sincurve_req_local <= '0';
      else
        if S_run = S_run_S_run_0008 and S_run_delay = 0 then
          paint_sincurve_req_local <= '1';
        elsif S_run = S_run_S_run_0007 and S_run_delay = 0 then
          paint_sincurve_req_local <= '1';
        elsif S_run = S_run_S_run_0006 and S_run_delay = 0 then
          paint_sincurve_req_local <= '1';
        elsif S_run = S_run_S_run_0005 and S_run_delay = 0 then
          paint_sincurve_req_local <= '1';
        else
          paint_sincurve_req_local <= '0';
        end if;
      end if;
    end if;
  end process;

  paint_sincurve_busy_sig <= tmp_0034;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        paint_sincurve_c_id_1 <= X"00000000";
      else
        if S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0012 then
          paint_sincurve_c_id_1 <= tmp_0035;
        elsif S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0006 then
          paint_sincurve_c_id_1 <= tmp_0050;
        elsif S_paint_sincurve = S_paint_sincurve_S_paint_sincurve_0004 then
          paint_sincurve_c_id_1 <= tmp_0051;
        end if;
      end if;
    end if;
  end process;

  obj_fill_rect_busy_0044 <= tmp_0048;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        sleep_n <= (others => '0');
      else
        if S_run = S_run_S_run_0004 and S_run_delay = 0 then
          sleep_n <= tmp_0098;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        sleep_req_local <= '0';
      else
        if S_run = S_run_S_run_0004 and S_run_delay = 0 then
          sleep_req_local <= '1';
        else
          sleep_req_local <= '0';
        end if;
      end if;
    end if;
  end process;

  sleep_busy_sig <= tmp_0059;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        run_req_local <= '0';
      else
        run_req_local <= '0';
      end if;
    end if;
  end process;

  init_colortbl_busy_sig_0069 <= tmp_0073;

  paint_sincurve_busy_sig_0075 <= tmp_0079;

  paint_sincurve_busy_sig_0081 <= tmp_0085;

  paint_sincurve_busy_sig_0087 <= tmp_0091;

  paint_sincurve_busy_sig_0093 <= tmp_0097;

  sleep_busy_sig_0099 <= tmp_0103;

  obj_flush_busy_0104 <= tmp_0108;


  inst_sin : sintable_rom
  port map(
    clk => sin_clk,
    reset => sin_reset,
    sintable_address => sin_sintable_address,
    sintable_din => sin_sintable_din,
    sintable_dout => sin_sintable_dout,
    sintable_length => sin_sintable_length,
    sintable_we => sin_sintable_we,
    sintable_oe => sin_sintable_oe
  );

  inst_colortbl : dualportram
  generic map(
    WIDTH => 32,
    DEPTH => 3,
    WORDS => 6
  )
  port map(
    clk => colortbl_clk,
    reset => colortbl_reset,
    length => colortbl_length,
    address => colortbl_address,
    din => colortbl_din,
    dout => colortbl_dout,
    we => colortbl_we,
    oe => colortbl_oe,
    address_b => colortbl_address_b,
    din_b => colortbl_din_b,
    dout_b => colortbl_dout_b,
    we_b => colortbl_we_b,
    oe_b => colortbl_oe_b
  );

  inst_obj : TestFrame
  port map(
    clk => obj_clk,
    reset => obj_reset,
    pset_x_in => obj_pset_x_in,
    pset_y_in => obj_pset_y_in,
    pset_color_in => obj_pset_color_in,
    pset_req => obj_pset_req,
    pset_busy => obj_pset_busy,
    clear_req => obj_clear_req,
    clear_busy => obj_clear_busy,
    fill_rect_x_in => obj_fill_rect_x_in,
    fill_rect_y_in => obj_fill_rect_y_in,
    fill_rect_w_in => obj_fill_rect_w_in,
    fill_rect_h_in => obj_fill_rect_h_in,
    fill_rect_c_in => obj_fill_rect_c_in,
    fill_rect_req => obj_fill_rect_req,
    fill_rect_busy => obj_fill_rect_busy,
    test_req => obj_test_req,
    test_busy => obj_test_busy,
    flush_req => obj_flush_req,
    flush_busy => obj_flush_busy,
    obj_obj_forbid => obj_obj_obj_forbid,
    obj_obj_axi_reader_ARADDR => obj_obj_obj_axi_reader_ARADDR,
    obj_obj_axi_reader_ARLEN => obj_obj_obj_axi_reader_ARLEN,
    obj_obj_axi_reader_ARVALID => obj_obj_obj_axi_reader_ARVALID,
    obj_obj_axi_reader_ARREADY => obj_obj_obj_axi_reader_ARREADY,
    obj_obj_axi_reader_ARSIZE => obj_obj_obj_axi_reader_ARSIZE,
    obj_obj_axi_reader_ARBURST => obj_obj_obj_axi_reader_ARBURST,
    obj_obj_axi_reader_ARCACHE => obj_obj_obj_axi_reader_ARCACHE,
    obj_obj_axi_reader_ARPROT => obj_obj_obj_axi_reader_ARPROT,
    obj_obj_axi_reader_RDATA => obj_obj_obj_axi_reader_RDATA,
    obj_obj_axi_reader_RRESP => obj_obj_obj_axi_reader_RRESP,
    obj_obj_axi_reader_RLAST => obj_obj_obj_axi_reader_RLAST,
    obj_obj_axi_reader_RVALID => obj_obj_obj_axi_reader_RVALID,
    obj_obj_axi_reader_RREADY => obj_obj_obj_axi_reader_RREADY,
    obj_obj_axi_writer_AWADDR => obj_obj_obj_axi_writer_AWADDR,
    obj_obj_axi_writer_AWLEN => obj_obj_obj_axi_writer_AWLEN,
    obj_obj_axi_writer_AWVALID => obj_obj_obj_axi_writer_AWVALID,
    obj_obj_axi_writer_AWSIZE => obj_obj_obj_axi_writer_AWSIZE,
    obj_obj_axi_writer_AWBURST => obj_obj_obj_axi_writer_AWBURST,
    obj_obj_axi_writer_AWCACHE => obj_obj_obj_axi_writer_AWCACHE,
    obj_obj_axi_writer_AWPROT => obj_obj_obj_axi_writer_AWPROT,
    obj_obj_axi_writer_AWREADY => obj_obj_obj_axi_writer_AWREADY,
    obj_obj_axi_writer_WDATA => obj_obj_obj_axi_writer_WDATA,
    obj_obj_axi_writer_WLAST => obj_obj_obj_axi_writer_WLAST,
    obj_obj_axi_writer_WVALID => obj_obj_obj_axi_writer_WVALID,
    obj_obj_axi_writer_WREADY => obj_obj_obj_axi_writer_WREADY,
    obj_obj_axi_writer_WSTRB => obj_obj_obj_axi_writer_WSTRB,
    obj_obj_axi_writer_BRESP => obj_obj_obj_axi_writer_BRESP,
    obj_obj_axi_writer_BVALID => obj_obj_obj_axi_writer_BVALID,
    obj_obj_axi_writer_BREADY => obj_obj_obj_axi_writer_BREADY
  );


end RTL;
