library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity TestFrame is
  port (
    clk : in std_logic;
    reset : in std_logic;
    obj_obj_forbid : in std_logic;
    obj_obj_axi_reader_ARADDR : out std_logic_vector(32-1 downto 0);
    obj_obj_axi_reader_ARLEN : out std_logic_vector(8-1 downto 0);
    obj_obj_axi_reader_ARVALID : out std_logic;
    obj_obj_axi_reader_ARREADY : in std_logic;
    obj_obj_axi_reader_ARSIZE : out std_logic_vector(3-1 downto 0);
    obj_obj_axi_reader_ARBURST : out std_logic_vector(2-1 downto 0);
    obj_obj_axi_reader_ARCACHE : out std_logic_vector(4-1 downto 0);
    obj_obj_axi_reader_ARPROT : out std_logic_vector(3-1 downto 0);
    obj_obj_axi_reader_RDATA : in std_logic_vector(32-1 downto 0);
    obj_obj_axi_reader_RRESP : in std_logic_vector(2-1 downto 0);
    obj_obj_axi_reader_RLAST : in std_logic;
    obj_obj_axi_reader_RVALID : in std_logic;
    obj_obj_axi_reader_RREADY : out std_logic;
    obj_obj_axi_writer_AWADDR : out std_logic_vector(32-1 downto 0);
    obj_obj_axi_writer_AWLEN : out std_logic_vector(8-1 downto 0);
    obj_obj_axi_writer_AWVALID : out std_logic;
    obj_obj_axi_writer_AWSIZE : out std_logic_vector(3-1 downto 0);
    obj_obj_axi_writer_AWBURST : out std_logic_vector(2-1 downto 0);
    obj_obj_axi_writer_AWCACHE : out std_logic_vector(4-1 downto 0);
    obj_obj_axi_writer_AWPROT : out std_logic_vector(3-1 downto 0);
    obj_obj_axi_writer_AWREADY : in std_logic;
    obj_obj_axi_writer_WDATA : out std_logic_vector(32-1 downto 0);
    obj_obj_axi_writer_WLAST : out std_logic;
    obj_obj_axi_writer_WVALID : out std_logic;
    obj_obj_axi_writer_WREADY : in std_logic;
    obj_obj_axi_writer_WSTRB : out std_logic_vector(4-1 downto 0);
    obj_obj_axi_writer_BRESP : in std_logic_vector(2-1 downto 0);
    obj_obj_axi_writer_BVALID : in std_logic;
    obj_obj_axi_writer_BREADY : out std_logic;
    pset_x_in : in signed(32-1 downto 0);
    pset_y_in : in signed(32-1 downto 0);
    pset_color_in : in signed(32-1 downto 0);
    pset_req : in std_logic;
    pset_busy : out std_logic;
    clear_req : in std_logic;
    clear_busy : out std_logic;
    fill_rect_x_in : in signed(32-1 downto 0);
    fill_rect_y_in : in signed(32-1 downto 0);
    fill_rect_w_in : in signed(32-1 downto 0);
    fill_rect_h_in : in signed(32-1 downto 0);
    fill_rect_c_in : in signed(32-1 downto 0);
    fill_rect_req : in std_logic;
    fill_rect_busy : out std_logic;
    test_req : in std_logic;
    test_busy : out std_logic;
    flush_req : in std_logic;
    flush_busy : out std_logic
  );
end TestFrame;

architecture RTL of TestFrame is

  component synthesijer_lib_axi_SimpleAXIMemIface32RTLTest
    port (
      clk : in std_logic;
      reset : in std_logic;
      obj_forbid : in std_logic;
      obj_axi_reader_ARADDR : out std_logic_vector(32-1 downto 0);
      obj_axi_reader_ARLEN : out std_logic_vector(8-1 downto 0);
      obj_axi_reader_ARVALID : out std_logic;
      obj_axi_reader_ARREADY : in std_logic;
      obj_axi_reader_ARSIZE : out std_logic_vector(3-1 downto 0);
      obj_axi_reader_ARBURST : out std_logic_vector(2-1 downto 0);
      obj_axi_reader_ARCACHE : out std_logic_vector(4-1 downto 0);
      obj_axi_reader_ARPROT : out std_logic_vector(3-1 downto 0);
      obj_axi_reader_RDATA : in std_logic_vector(32-1 downto 0);
      obj_axi_reader_RRESP : in std_logic_vector(2-1 downto 0);
      obj_axi_reader_RLAST : in std_logic;
      obj_axi_reader_RVALID : in std_logic;
      obj_axi_reader_RREADY : out std_logic;
      obj_axi_writer_AWADDR : out std_logic_vector(32-1 downto 0);
      obj_axi_writer_AWLEN : out std_logic_vector(8-1 downto 0);
      obj_axi_writer_AWVALID : out std_logic;
      obj_axi_writer_AWSIZE : out std_logic_vector(3-1 downto 0);
      obj_axi_writer_AWBURST : out std_logic_vector(2-1 downto 0);
      obj_axi_writer_AWCACHE : out std_logic_vector(4-1 downto 0);
      obj_axi_writer_AWPROT : out std_logic_vector(3-1 downto 0);
      obj_axi_writer_AWREADY : in std_logic;
      obj_axi_writer_WDATA : out std_logic_vector(32-1 downto 0);
      obj_axi_writer_WLAST : out std_logic;
      obj_axi_writer_WVALID : out std_logic;
      obj_axi_writer_WREADY : in std_logic;
      obj_axi_writer_WSTRB : out std_logic_vector(4-1 downto 0);
      obj_axi_writer_BRESP : in std_logic_vector(2-1 downto 0);
      obj_axi_writer_BVALID : in std_logic;
      obj_axi_writer_BREADY : out std_logic;
      write_data_addr_in : in signed(32-1 downto 0);
      write_data_data_in : in signed(32-1 downto 0);
      write_data_req : in std_logic;
      write_data_busy : out std_logic;
      read_data_addr_in : in signed(32-1 downto 0);
      read_data_return : out signed(32-1 downto 0);
      read_data_req : in std_logic;
      read_data_busy : out std_logic;
      test_req : in std_logic;
      test_busy : out std_logic
    );
  end component synthesijer_lib_axi_SimpleAXIMemIface32RTLTest;

  signal clk_sig : std_logic;
  signal reset_sig : std_logic;
  signal pset_x_in_sig : signed(32-1 downto 0);
  signal pset_y_in_sig : signed(32-1 downto 0);
  signal pset_color_in_sig : signed(32-1 downto 0);
  signal pset_req_sig : std_logic;
  signal pset_busy_sig : std_logic;
  signal clear_req_sig : std_logic;
  signal clear_busy_sig : std_logic;
  signal fill_rect_x_in_sig : signed(32-1 downto 0);
  signal fill_rect_y_in_sig : signed(32-1 downto 0);
  signal fill_rect_w_in_sig : signed(32-1 downto 0);
  signal fill_rect_h_in_sig : signed(32-1 downto 0);
  signal fill_rect_c_in_sig : signed(32-1 downto 0);
  signal fill_rect_req_sig : std_logic;
  signal fill_rect_busy_sig : std_logic;
  signal test_req_sig : std_logic;
  signal test_busy_sig : std_logic;
  signal flush_req_sig : std_logic;
  signal flush_busy_sig : std_logic;

  signal obj_clk : std_logic;
  signal obj_reset : std_logic;
  signal obj_write_data_addr_in : signed(32-1 downto 0) := (others => '0');
  signal obj_write_data_data_in : signed(32-1 downto 0) := (others => '0');
  signal obj_write_data_req : std_logic := '0';
  signal obj_write_data_busy : std_logic;
  signal obj_read_data_addr_in : signed(32-1 downto 0) := (others => '0');
  signal obj_read_data_return : signed(32-1 downto 0);
  signal obj_read_data_req : std_logic := '0';
  signal obj_read_data_busy : std_logic;
  signal obj_test_req : std_logic := '0';
  signal obj_test_busy : std_logic;
  signal clear_i_1 : signed(32-1 downto 0) := X"00000000";
  signal clear_j_0 : signed(32-1 downto 0) := X"00000000";
  signal fill_rect_i_6 : signed(32-1 downto 0) := X"00000000";
  signal fill_rect_j_5 : signed(32-1 downto 0) := X"00000000";
  signal test_i_1 : signed(32-1 downto 0) := X"0000001e";
  signal test_j_0 : signed(32-1 downto 0) := X"0000001e";
  type Type_methodId is (
    IDLE,
    method_set_color_0,
    method_set_color_1,
    method_set_color_2,
    method_set_color_3,
    method_pset,
    method_clear,
    method_fill_rect,
    method_test,
    method_flush  
  );
  signal methodId : Type_methodId := IDLE;
  signal set_color_0_base : signed(32-1 downto 0) := (others => '0');
  signal set_color_0_color : signed(32-1 downto 0) := (others => '0');
  signal set_color_0_req_local : std_logic := '0';
  signal tmp_0001 : std_logic;
  signal set_color_0_busy_sig : std_logic;
  signal set_color_0_v_2 : signed(32-1 downto 0) := X"00000000";
  type Type_S_set_color_0 is (
    S_set_color_0_IDLE,
    S_set_color_0_S_set_color_0_0001,
    S_set_color_0_S_set_color_0_0002,
    S_set_color_0_S_set_color_0_0003,
    S_set_color_0_S_set_color_0_0004,
    S_set_color_0_S_set_color_0_0005  
  );
  signal S_set_color_0 : Type_S_set_color_0 := S_set_color_0_IDLE;
  signal S_set_color_0_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0002 : std_logic;
  signal tmp_0003 : std_logic;
  signal tmp_0004 : signed(32-1 downto 0);
  signal obj_read_data_busy_0005 : std_logic;
  signal tmp_0006 : std_logic;
  signal tmp_0007 : std_logic;
  signal tmp_0008 : std_logic;
  signal tmp_0009 : std_logic;
  signal tmp_0010 : signed(32-1 downto 0);
  signal tmp_0011 : signed(32-1 downto 0);
  signal tmp_0012 : signed(32-1 downto 0);
  signal tmp_0013 : signed(32-1 downto 0);
  signal tmp_0014 : signed(32-1 downto 0);
  signal obj_write_data_busy_0015 : std_logic;
  signal tmp_0016 : std_logic;
  signal tmp_0017 : std_logic;
  signal tmp_0018 : std_logic;
  signal tmp_0019 : std_logic;
  signal set_color_1_base : signed(32-1 downto 0) := (others => '0');
  signal set_color_1_color : signed(32-1 downto 0) := (others => '0');
  signal set_color_1_req_local : std_logic := '0';
  signal tmp_0020 : std_logic;
  signal set_color_1_busy_sig : std_logic;
  signal set_color_1_v_2 : signed(32-1 downto 0) := X"00000000";
  type Type_S_set_color_1 is (
    S_set_color_1_IDLE,
    S_set_color_1_S_set_color_1_0001,
    S_set_color_1_S_set_color_1_0002,
    S_set_color_1_S_set_color_1_0003,
    S_set_color_1_S_set_color_1_0004,
    S_set_color_1_S_set_color_1_0005  
  );
  signal S_set_color_1 : Type_S_set_color_1 := S_set_color_1_IDLE;
  signal S_set_color_1_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0021 : std_logic;
  signal tmp_0022 : std_logic;
  signal tmp_0023 : signed(32-1 downto 0);
  signal obj_read_data_busy_0024 : std_logic;
  signal tmp_0025 : std_logic;
  signal tmp_0026 : std_logic;
  signal tmp_0027 : std_logic;
  signal tmp_0028 : std_logic;
  signal tmp_0029 : signed(32-1 downto 0);
  signal tmp_0030 : signed(32-1 downto 0);
  signal tmp_0031 : signed(32-1 downto 0);
  signal tmp_0032 : signed(32-1 downto 0);
  signal tmp_0033 : signed(32-1 downto 0);
  signal tmp_0034 : signed(32-1 downto 0);
  signal tmp_0035 : signed(32-1 downto 0);
  signal obj_write_data_busy_0036 : std_logic;
  signal tmp_0037 : std_logic;
  signal tmp_0038 : std_logic;
  signal tmp_0039 : std_logic;
  signal tmp_0040 : std_logic;
  signal set_color_2_base : signed(32-1 downto 0) := (others => '0');
  signal set_color_2_color : signed(32-1 downto 0) := (others => '0');
  signal set_color_2_req_local : std_logic := '0';
  signal tmp_0041 : std_logic;
  signal set_color_2_busy_sig : std_logic;
  signal set_color_2_v_2 : signed(32-1 downto 0) := X"00000000";
  type Type_S_set_color_2 is (
    S_set_color_2_IDLE,
    S_set_color_2_S_set_color_2_0001,
    S_set_color_2_S_set_color_2_0002,
    S_set_color_2_S_set_color_2_0003,
    S_set_color_2_S_set_color_2_0004,
    S_set_color_2_S_set_color_2_0005,
    S_set_color_2_S_set_color_2_0006,
    S_set_color_2_S_set_color_2_0007,
    S_set_color_2_S_set_color_2_0008  
  );
  signal S_set_color_2 : Type_S_set_color_2 := S_set_color_2_IDLE;
  signal S_set_color_2_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0042 : std_logic;
  signal tmp_0043 : std_logic;
  signal tmp_0044 : signed(32-1 downto 0);
  signal obj_read_data_busy_0045 : std_logic;
  signal tmp_0046 : std_logic;
  signal tmp_0047 : std_logic;
  signal tmp_0048 : std_logic;
  signal tmp_0049 : std_logic;
  signal tmp_0050 : signed(32-1 downto 0);
  signal tmp_0051 : signed(32-1 downto 0);
  signal tmp_0052 : signed(32-1 downto 0);
  signal tmp_0053 : signed(32-1 downto 0);
  signal tmp_0054 : signed(32-1 downto 0);
  signal tmp_0055 : signed(32-1 downto 0);
  signal tmp_0056 : signed(32-1 downto 0);
  signal obj_write_data_busy_0057 : std_logic;
  signal tmp_0058 : std_logic;
  signal tmp_0059 : std_logic;
  signal tmp_0060 : std_logic;
  signal tmp_0061 : std_logic;
  signal tmp_0062 : signed(32-1 downto 0);
  signal tmp_0063 : signed(32-1 downto 0);
  signal obj_read_data_busy_0064 : std_logic;
  signal tmp_0065 : std_logic;
  signal tmp_0066 : std_logic;
  signal tmp_0067 : std_logic;
  signal tmp_0068 : std_logic;
  signal tmp_0069 : signed(32-1 downto 0);
  signal tmp_0070 : signed(32-1 downto 0);
  signal tmp_0071 : signed(32-1 downto 0);
  signal tmp_0072 : signed(32-1 downto 0);
  signal tmp_0073 : signed(32-1 downto 0);
  signal tmp_0074 : signed(32-1 downto 0);
  signal tmp_0075 : signed(32-1 downto 0);
  signal tmp_0076 : signed(32-1 downto 0);
  signal tmp_0077 : signed(32-1 downto 0);
  signal obj_write_data_busy_0078 : std_logic;
  signal tmp_0079 : std_logic;
  signal tmp_0080 : std_logic;
  signal tmp_0081 : std_logic;
  signal tmp_0082 : std_logic;
  signal set_color_3_base : signed(32-1 downto 0) := (others => '0');
  signal set_color_3_color : signed(32-1 downto 0) := (others => '0');
  signal set_color_3_req_local : std_logic := '0';
  signal tmp_0083 : std_logic;
  signal set_color_3_busy_sig : std_logic;
  signal set_color_3_v_2 : signed(32-1 downto 0) := X"00000000";
  type Type_S_set_color_3 is (
    S_set_color_3_IDLE,
    S_set_color_3_S_set_color_3_0001,
    S_set_color_3_S_set_color_3_0002,
    S_set_color_3_S_set_color_3_0003,
    S_set_color_3_S_set_color_3_0004,
    S_set_color_3_S_set_color_3_0005,
    S_set_color_3_S_set_color_3_0006,
    S_set_color_3_S_set_color_3_0007,
    S_set_color_3_S_set_color_3_0008  
  );
  signal S_set_color_3 : Type_S_set_color_3 := S_set_color_3_IDLE;
  signal S_set_color_3_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0084 : std_logic;
  signal tmp_0085 : std_logic;
  signal tmp_0086 : signed(32-1 downto 0);
  signal obj_read_data_busy_0087 : std_logic;
  signal tmp_0088 : std_logic;
  signal tmp_0089 : std_logic;
  signal tmp_0090 : std_logic;
  signal tmp_0091 : std_logic;
  signal tmp_0092 : signed(32-1 downto 0);
  signal tmp_0093 : signed(32-1 downto 0);
  signal tmp_0094 : signed(32-1 downto 0);
  signal tmp_0095 : signed(32-1 downto 0);
  signal tmp_0096 : signed(32-1 downto 0);
  signal tmp_0097 : signed(32-1 downto 0);
  signal tmp_0098 : signed(32-1 downto 0);
  signal obj_write_data_busy_0099 : std_logic;
  signal tmp_0100 : std_logic;
  signal tmp_0101 : std_logic;
  signal tmp_0102 : std_logic;
  signal tmp_0103 : std_logic;
  signal tmp_0104 : signed(32-1 downto 0);
  signal tmp_0105 : signed(32-1 downto 0);
  signal obj_read_data_busy_0106 : std_logic;
  signal tmp_0107 : std_logic;
  signal tmp_0108 : std_logic;
  signal tmp_0109 : std_logic;
  signal tmp_0110 : std_logic;
  signal tmp_0111 : signed(32-1 downto 0);
  signal tmp_0112 : signed(32-1 downto 0);
  signal tmp_0113 : signed(32-1 downto 0);
  signal tmp_0114 : signed(32-1 downto 0);
  signal tmp_0115 : signed(32-1 downto 0);
  signal tmp_0116 : signed(32-1 downto 0);
  signal tmp_0117 : signed(32-1 downto 0);
  signal tmp_0118 : signed(32-1 downto 0);
  signal tmp_0119 : signed(32-1 downto 0);
  signal obj_write_data_busy_0120 : std_logic;
  signal tmp_0121 : std_logic;
  signal tmp_0122 : std_logic;
  signal tmp_0123 : std_logic;
  signal tmp_0124 : std_logic;
  signal pset_x : signed(32-1 downto 0) := (others => '0');
  signal pset_y : signed(32-1 downto 0) := (others => '0');
  signal pset_color : signed(32-1 downto 0) := (others => '0');
  signal pset_req_local : std_logic := '0';
  signal tmp_0125 : std_logic;
  signal pset_idx_4 : signed(32-1 downto 0) := (others => '0');
  signal pset_v_7 : signed(32-1 downto 0) := X"00000000";
  signal pset_base_3 : signed(32-1 downto 0) := (others => '0');
  signal pset_pt_6 : signed(32-1 downto 0) := (others => '0');
  signal pset_offset_5 : signed(32-1 downto 0) := X"3f000000";
  type Type_S_pset is (
    S_pset_IDLE,
    S_pset_S_pset_0001,
    S_pset_S_pset_0002,
    S_pset_S_pset_0003,
    S_pset_S_pset_0004,
    S_pset_S_pset_0005,
    S_pset_S_pset_0006,
    S_pset_S_pset_0007,
    S_pset_S_pset_0008,
    S_pset_S_pset_0009,
    S_pset_S_pset_0010,
    S_pset_S_pset_0011,
    S_pset_S_pset_0012,
    S_pset_S_pset_0014,
    S_pset_S_pset_0016,
    S_pset_S_pset_0018  
  );
  signal S_pset : Type_S_pset := S_pset_IDLE;
  signal S_pset_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0126 : signed(32-1 downto 0);
  signal tmp_0127 : std_logic;
  signal tmp_0128 : signed(32-1 downto 0);
  signal tmp_0129 : std_logic;
  signal tmp_0130 : signed(32-1 downto 0);
  signal tmp_0131 : std_logic;
  signal tmp_0132 : signed(32-1 downto 0);
  signal tmp_0133 : std_logic;
  signal tmp_0134 : std_logic;
  signal tmp_0135 : std_logic;
  signal tmp_0136 : signed(32-1 downto 0);
  signal tmp_0137 : signed(32-1 downto 0);
  signal tmp_0138 : signed(32-1 downto 0);
  signal tmp_0139 : signed(32-1 downto 0);
  signal tmp_0140 : signed(32-1 downto 0);
  signal tmp_0141 : signed(32-1 downto 0);
  signal tmp_0142 : signed(32-1 downto 0);
  signal tmp_0143 : signed(32-1 downto 0);
  signal tmp_0144 : signed(32-1 downto 0);
  signal tmp_0145 : signed(32-1 downto 0);
  signal tmp_0146 : signed(32-1 downto 0);
  signal tmp_0147 : signed(32-1 downto 0);
  signal tmp_0148 : signed(32-1 downto 0);
  signal tmp_0149 : signed(32-1 downto 0);
  signal tmp_0150 : signed(32-1 downto 0);
  signal tmp_0151 : signed(32-1 downto 0);
  signal tmp_0152 : signed(32-1 downto 0);
  signal tmp_0153 : signed(32-1 downto 0);
  signal tmp_0154 : signed(32-1 downto 0);
  signal tmp_0155 : signed(32-1 downto 0);
  signal tmp_0156 : signed(32-1 downto 0);
  signal tmp_0157 : signed(32-1 downto 0);
  signal tmp_0158 : signed(32-1 downto 0);
  signal tmp_0159 : signed(32-1 downto 0);
  signal tmp_0160 : signed(32-1 downto 0);
  signal set_color_0_busy_sig_0161 : std_logic;
  signal tmp_0162 : std_logic;
  signal tmp_0163 : std_logic;
  signal tmp_0164 : std_logic;
  signal tmp_0165 : std_logic;
  signal set_color_1_busy_sig_0166 : std_logic;
  signal tmp_0167 : std_logic;
  signal tmp_0168 : std_logic;
  signal tmp_0169 : std_logic;
  signal tmp_0170 : std_logic;
  signal set_color_2_busy_sig_0171 : std_logic;
  signal tmp_0172 : std_logic;
  signal tmp_0173 : std_logic;
  signal tmp_0174 : std_logic;
  signal tmp_0175 : std_logic;
  signal set_color_3_busy_sig_0176 : std_logic;
  signal tmp_0177 : std_logic;
  signal tmp_0178 : std_logic;
  signal tmp_0179 : std_logic;
  signal tmp_0180 : std_logic;
  signal tmp_0181 : std_logic;
  signal tmp_0182 : std_logic;
  signal tmp_0183 : signed(32-1 downto 0);
  signal tmp_0184 : std_logic;
  signal tmp_0185 : std_logic;
  signal tmp_0186 : signed(32-1 downto 0);
  signal tmp_0187 : std_logic;
  signal tmp_0188 : std_logic;
  signal tmp_0189 : signed(32-1 downto 0);
  signal clear_req_local : std_logic := '0';
  signal tmp_0190 : std_logic;
  type Type_S_clear is (
    S_clear_IDLE,
    S_clear_S_clear_0001,
    S_clear_S_clear_0002,
    S_clear_S_clear_0003,
    S_clear_S_clear_0004,
    S_clear_S_clear_0005,
    S_clear_S_clear_0006,
    S_clear_S_clear_0007,
    S_clear_S_clear_0008  
  );
  signal S_clear : Type_S_clear := S_clear_IDLE;
  signal S_clear_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0191 : signed(32-1 downto 0);
  signal tmp_0192 : std_logic;
  signal tmp_0193 : std_logic;
  signal tmp_0194 : signed(32-1 downto 0);
  signal tmp_0195 : std_logic;
  signal tmp_0196 : std_logic;
  signal tmp_0197 : signed(32-1 downto 0);
  signal tmp_0198 : std_logic;
  signal tmp_0199 : std_logic;
  signal tmp_0200 : signed(32-1 downto 0);
  signal tmp_0201 : std_logic;
  signal tmp_0202 : std_logic;
  signal tmp_0203 : std_logic;
  signal tmp_0204 : std_logic;
  signal tmp_0205 : signed(32-1 downto 0);
  signal tmp_0206 : signed(32-1 downto 0);
  signal tmp_0207 : signed(32-1 downto 0);
  signal pset_busy_sig_0208 : std_logic;
  signal tmp_0209 : std_logic;
  signal tmp_0210 : std_logic;
  signal tmp_0211 : std_logic;
  signal tmp_0212 : std_logic;
  signal tmp_0213 : signed(32-1 downto 0);
  signal tmp_0214 : signed(32-1 downto 0);
  signal fill_rect_x : signed(32-1 downto 0) := (others => '0');
  signal fill_rect_y : signed(32-1 downto 0) := (others => '0');
  signal fill_rect_w : signed(32-1 downto 0) := (others => '0');
  signal fill_rect_h : signed(32-1 downto 0) := (others => '0');
  signal fill_rect_c : signed(32-1 downto 0) := (others => '0');
  signal fill_rect_req_local : std_logic := '0';
  signal tmp_0215 : std_logic;
  type Type_S_fill_rect is (
    S_fill_rect_IDLE,
    S_fill_rect_S_fill_rect_0001,
    S_fill_rect_S_fill_rect_0002,
    S_fill_rect_S_fill_rect_0003,
    S_fill_rect_S_fill_rect_0004,
    S_fill_rect_S_fill_rect_0005,
    S_fill_rect_S_fill_rect_0006,
    S_fill_rect_S_fill_rect_0007,
    S_fill_rect_S_fill_rect_0008  
  );
  signal S_fill_rect : Type_S_fill_rect := S_fill_rect_IDLE;
  signal S_fill_rect_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0216 : std_logic;
  signal tmp_0217 : std_logic;
  signal tmp_0218 : std_logic;
  signal tmp_0219 : std_logic;
  signal tmp_0220 : std_logic;
  signal tmp_0221 : std_logic;
  signal tmp_0222 : std_logic;
  signal tmp_0223 : std_logic;
  signal tmp_0224 : std_logic;
  signal tmp_0225 : std_logic;
  signal tmp_0226 : signed(32-1 downto 0);
  signal tmp_0227 : signed(32-1 downto 0);
  signal tmp_0228 : signed(32-1 downto 0);
  signal tmp_0229 : signed(32-1 downto 0);
  signal pset_busy_sig_0230 : std_logic;
  signal tmp_0231 : std_logic;
  signal tmp_0232 : std_logic;
  signal tmp_0233 : std_logic;
  signal tmp_0234 : std_logic;
  signal tmp_0235 : signed(32-1 downto 0);
  signal tmp_0236 : signed(32-1 downto 0);
  signal tmp_0237 : std_logic;
  signal tmp_0238 : std_logic;
  signal tmp_0239 : signed(32-1 downto 0);
  signal tmp_0240 : std_logic;
  signal tmp_0241 : std_logic;
  signal tmp_0242 : signed(32-1 downto 0);
  signal tmp_0243 : std_logic;
  signal tmp_0244 : std_logic;
  signal tmp_0245 : signed(32-1 downto 0);
  signal tmp_0246 : std_logic;
  signal tmp_0247 : std_logic;
  signal tmp_0248 : signed(32-1 downto 0);
  signal tmp_0249 : std_logic;
  signal tmp_0250 : std_logic;
  signal tmp_0251 : signed(32-1 downto 0);
  signal test_req_local : std_logic := '0';
  signal tmp_0252 : std_logic;
  type Type_S_test is (
    S_test_IDLE,
    S_test_S_test_0001,
    S_test_S_test_0002,
    S_test_S_test_0003,
    S_test_S_test_0004,
    S_test_S_test_0005,
    S_test_S_test_0006,
    S_test_S_test_0007,
    S_test_S_test_0008  
  );
  signal S_test : Type_S_test := S_test_IDLE;
  signal S_test_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0253 : signed(32-1 downto 0);
  signal tmp_0254 : std_logic;
  signal tmp_0255 : std_logic;
  signal tmp_0256 : signed(32-1 downto 0);
  signal tmp_0257 : std_logic;
  signal tmp_0258 : std_logic;
  signal tmp_0259 : signed(32-1 downto 0);
  signal tmp_0260 : std_logic;
  signal tmp_0261 : std_logic;
  signal tmp_0262 : signed(32-1 downto 0);
  signal tmp_0263 : std_logic;
  signal tmp_0264 : std_logic;
  signal tmp_0265 : std_logic;
  signal tmp_0266 : std_logic;
  signal tmp_0267 : signed(32-1 downto 0);
  signal tmp_0268 : signed(32-1 downto 0);
  signal tmp_0269 : signed(32-1 downto 0);
  signal pset_busy_sig_0270 : std_logic;
  signal tmp_0271 : std_logic;
  signal tmp_0272 : std_logic;
  signal tmp_0273 : std_logic;
  signal tmp_0274 : std_logic;
  signal tmp_0275 : signed(32-1 downto 0);
  signal tmp_0276 : signed(32-1 downto 0);
  signal flush_req_local : std_logic := '0';
  signal tmp_0277 : std_logic;
  type Type_S_flush is (
    S_flush_IDLE,
    S_flush_S_flush_0001  
  );
  signal S_flush : Type_S_flush := S_flush_IDLE;
  signal S_flush_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0278 : std_logic;
  signal tmp_0279 : std_logic;

begin

  clk_sig <= clk;
  reset_sig <= reset;
  pset_x_in_sig <= pset_x_in;
  pset_y_in_sig <= pset_y_in;
  pset_color_in_sig <= pset_color_in;
  pset_req_sig <= pset_req;
  pset_busy <= pset_busy_sig;
  pset_busy_sig <= tmp_0135;

  clear_req_sig <= clear_req;
  clear_busy <= clear_busy_sig;
  clear_busy_sig <= tmp_0204;

  fill_rect_x_in_sig <= fill_rect_x_in;
  fill_rect_y_in_sig <= fill_rect_y_in;
  fill_rect_w_in_sig <= fill_rect_w_in;
  fill_rect_h_in_sig <= fill_rect_h_in;
  fill_rect_c_in_sig <= fill_rect_c_in;
  fill_rect_req_sig <= fill_rect_req;
  fill_rect_busy <= fill_rect_busy_sig;
  fill_rect_busy_sig <= tmp_0225;

  test_req_sig <= test_req;
  test_busy <= test_busy_sig;
  test_busy_sig <= tmp_0266;

  flush_req_sig <= flush_req;
  flush_busy <= flush_busy_sig;
  flush_busy_sig <= tmp_0279;


  -- expressions
  tmp_0001 <= '1' when set_color_0_req_local = '1' else '0';
  tmp_0002 <= '1' when S_set_color_0 = S_set_color_0_IDLE else '0';
  tmp_0003 <= '0' when tmp_0002 = '1' else '1';
  tmp_0004 <= X"00000000";
  tmp_0006 <= '1' when obj_read_data_busy = '0' else '0';
  tmp_0007 <= '1' when obj_read_data_req = '0' else '0';
  tmp_0008 <= tmp_0006 and tmp_0007;
  tmp_0009 <= '1' when tmp_0008 = '1' else '0';
  tmp_0010 <= X"ff000000";
  tmp_0011 <= set_color_0_v_2 and tmp_0010;
  tmp_0012 <= X"00ffffff";
  tmp_0013 <= set_color_0_color and tmp_0012;
  tmp_0014 <= tmp_0011 or tmp_0013;
  tmp_0016 <= '1' when obj_write_data_busy = '0' else '0';
  tmp_0017 <= '1' when obj_write_data_req = '0' else '0';
  tmp_0018 <= tmp_0016 and tmp_0017;
  tmp_0019 <= '1' when tmp_0018 = '1' else '0';
  tmp_0020 <= '1' when set_color_1_req_local = '1' else '0';
  tmp_0021 <= '1' when S_set_color_1 = S_set_color_1_IDLE else '0';
  tmp_0022 <= '0' when tmp_0021 = '1' else '1';
  tmp_0023 <= X"00000000";
  tmp_0025 <= '1' when obj_read_data_busy = '0' else '0';
  tmp_0026 <= '1' when obj_read_data_req = '0' else '0';
  tmp_0027 <= tmp_0025 and tmp_0026;
  tmp_0028 <= '1' when tmp_0027 = '1' else '0';
  tmp_0029 <= X"000000ff";
  tmp_0030 <= set_color_1_v_2 and tmp_0029;
  tmp_0031 <= X"00ffffff";
  tmp_0032 <= set_color_1_color and tmp_0031;
  tmp_0033 <= X"00000008";
  tmp_0034 <= tmp_0032(23 downto 0) & (8-1 downto 0 => '0');
  tmp_0035 <= tmp_0030 or tmp_0034;
  tmp_0037 <= '1' when obj_write_data_busy = '0' else '0';
  tmp_0038 <= '1' when obj_write_data_req = '0' else '0';
  tmp_0039 <= tmp_0037 and tmp_0038;
  tmp_0040 <= '1' when tmp_0039 = '1' else '0';
  tmp_0041 <= '1' when set_color_2_req_local = '1' else '0';
  tmp_0042 <= '1' when S_set_color_2 = S_set_color_2_IDLE else '0';
  tmp_0043 <= '0' when tmp_0042 = '1' else '1';
  tmp_0044 <= X"00000000";
  tmp_0046 <= '1' when obj_read_data_busy = '0' else '0';
  tmp_0047 <= '1' when obj_read_data_req = '0' else '0';
  tmp_0048 <= tmp_0046 and tmp_0047;
  tmp_0049 <= '1' when tmp_0048 = '1' else '0';
  tmp_0050 <= X"0000ffff";
  tmp_0051 <= set_color_2_v_2 and tmp_0050;
  tmp_0052 <= X"0000ffff";
  tmp_0053 <= set_color_2_color and tmp_0052;
  tmp_0054 <= X"00000010";
  tmp_0055 <= tmp_0053(15 downto 0) & (16-1 downto 0 => '0');
  tmp_0056 <= tmp_0051 or tmp_0055;
  tmp_0058 <= '1' when obj_write_data_busy = '0' else '0';
  tmp_0059 <= '1' when obj_write_data_req = '0' else '0';
  tmp_0060 <= tmp_0058 and tmp_0059;
  tmp_0061 <= '1' when tmp_0060 = '1' else '0';
  tmp_0062 <= X"00000004";
  tmp_0063 <= set_color_2_base + tmp_0062;
  tmp_0065 <= '1' when obj_read_data_busy = '0' else '0';
  tmp_0066 <= '1' when obj_read_data_req = '0' else '0';
  tmp_0067 <= tmp_0065 and tmp_0066;
  tmp_0068 <= '1' when tmp_0067 = '1' else '0';
  tmp_0069 <= X"ffffff00";
  tmp_0070 <= set_color_2_v_2 and tmp_0069;
  tmp_0071 <= X"00ff0000";
  tmp_0072 <= set_color_2_color and tmp_0071;
  tmp_0073 <= X"00000010";
  tmp_0074 <= (16-1 downto 0 => tmp_0072(31)) & tmp_0072(31 downto 16);
  tmp_0075 <= tmp_0070 or tmp_0074;
  tmp_0076 <= X"00000004";
  tmp_0077 <= set_color_2_base + tmp_0076;
  tmp_0079 <= '1' when obj_write_data_busy = '0' else '0';
  tmp_0080 <= '1' when obj_write_data_req = '0' else '0';
  tmp_0081 <= tmp_0079 and tmp_0080;
  tmp_0082 <= '1' when tmp_0081 = '1' else '0';
  tmp_0083 <= '1' when set_color_3_req_local = '1' else '0';
  tmp_0084 <= '1' when S_set_color_3 = S_set_color_3_IDLE else '0';
  tmp_0085 <= '0' when tmp_0084 = '1' else '1';
  tmp_0086 <= X"00000000";
  tmp_0088 <= '1' when obj_read_data_busy = '0' else '0';
  tmp_0089 <= '1' when obj_read_data_req = '0' else '0';
  tmp_0090 <= tmp_0088 and tmp_0089;
  tmp_0091 <= '1' when tmp_0090 = '1' else '0';
  tmp_0092 <= X"00ffffff";
  tmp_0093 <= set_color_3_v_2 and tmp_0092;
  tmp_0094 <= X"000000ff";
  tmp_0095 <= set_color_3_color and tmp_0094;
  tmp_0096 <= X"00000018";
  tmp_0097 <= tmp_0095(7 downto 0) & (24-1 downto 0 => '0');
  tmp_0098 <= tmp_0093 or tmp_0097;
  tmp_0100 <= '1' when obj_write_data_busy = '0' else '0';
  tmp_0101 <= '1' when obj_write_data_req = '0' else '0';
  tmp_0102 <= tmp_0100 and tmp_0101;
  tmp_0103 <= '1' when tmp_0102 = '1' else '0';
  tmp_0104 <= X"00000004";
  tmp_0105 <= set_color_3_base + tmp_0104;
  tmp_0107 <= '1' when obj_read_data_busy = '0' else '0';
  tmp_0108 <= '1' when obj_read_data_req = '0' else '0';
  tmp_0109 <= tmp_0107 and tmp_0108;
  tmp_0110 <= '1' when tmp_0109 = '1' else '0';
  tmp_0111 <= X"ffff0000";
  tmp_0112 <= set_color_3_v_2 and tmp_0111;
  tmp_0113 <= X"00ffff00";
  tmp_0114 <= set_color_3_color and tmp_0113;
  tmp_0115 <= X"00000008";
  tmp_0116 <= (8-1 downto 0 => tmp_0114(31)) & tmp_0114(31 downto 8);
  tmp_0117 <= tmp_0112 or tmp_0116;
  tmp_0118 <= X"00000004";
  tmp_0119 <= set_color_3_base + tmp_0118;
  tmp_0121 <= '1' when obj_write_data_busy = '0' else '0';
  tmp_0122 <= '1' when obj_write_data_req = '0' else '0';
  tmp_0123 <= tmp_0121 and tmp_0122;
  tmp_0124 <= '1' when tmp_0123 = '1' else '0';
  tmp_0125 <= pset_req_sig or pset_req_local;
  tmp_0126 <= X"00000000";
  tmp_0127 <= '1' when pset_idx_4 = tmp_0126 else '0';
  tmp_0128 <= X"00000001";
  tmp_0129 <= '1' when pset_idx_4 = tmp_0128 else '0';
  tmp_0130 <= X"00000002";
  tmp_0131 <= '1' when pset_idx_4 = tmp_0130 else '0';
  tmp_0132 <= X"00000003";
  tmp_0133 <= '1' when pset_idx_4 = tmp_0132 else '0';
  tmp_0134 <= '1' when S_pset = S_pset_IDLE else '0';
  tmp_0135 <= '0' when tmp_0134 = '1' else '1';
  tmp_0136 <= X"3f000000";
  tmp_0137 <= X"0000000a";
  tmp_0138 <= pset_y(21 downto 0) & (10-1 downto 0 => '0');
  tmp_0139 <= X"00000009";
  tmp_0140 <= pset_y(22 downto 0) & (9-1 downto 0 => '0');
  tmp_0141 <= tmp_0138 + tmp_0140;
  tmp_0142 <= X"00000008";
  tmp_0143 <= pset_y(23 downto 0) & (8-1 downto 0 => '0');
  tmp_0144 <= tmp_0141 + tmp_0143;
  tmp_0145 <= X"00000007";
  tmp_0146 <= pset_y(24 downto 0) & (7-1 downto 0 => '0');
  tmp_0147 <= tmp_0144 + tmp_0146;
  tmp_0148 <= tmp_0147 + pset_x;
  tmp_0149 <= X"00000001";
  tmp_0150 <= pset_pt_6(30 downto 0) & (1-1 downto 0 => '0');
  tmp_0151 <= tmp_0150 + pset_pt_6;
  tmp_0152 <= X"fffffffc";
  tmp_0153 <= tmp_0151 and tmp_0152;
  tmp_0154 <= X"00000001";
  tmp_0155 <= pset_pt_6(30 downto 0) & (1-1 downto 0 => '0');
  tmp_0156 <= tmp_0155 + pset_pt_6;
  tmp_0157 <= X"00000003";
  tmp_0158 <= tmp_0156 and tmp_0157;
  tmp_0159 <= pset_base_3 + pset_offset_5;
  tmp_0160 <= X"00000000";
  tmp_0162 <= '1' when set_color_0_busy_sig = '0' else '0';
  tmp_0163 <= '1' when set_color_0_req_local = '0' else '0';
  tmp_0164 <= tmp_0162 and tmp_0163;
  tmp_0165 <= '1' when tmp_0164 = '1' else '0';
  tmp_0167 <= '1' when set_color_1_busy_sig = '0' else '0';
  tmp_0168 <= '1' when set_color_1_req_local = '0' else '0';
  tmp_0169 <= tmp_0167 and tmp_0168;
  tmp_0170 <= '1' when tmp_0169 = '1' else '0';
  tmp_0172 <= '1' when set_color_2_busy_sig = '0' else '0';
  tmp_0173 <= '1' when set_color_2_req_local = '0' else '0';
  tmp_0174 <= tmp_0172 and tmp_0173;
  tmp_0175 <= '1' when tmp_0174 = '1' else '0';
  tmp_0177 <= '1' when set_color_3_busy_sig = '0' else '0';
  tmp_0178 <= '1' when set_color_3_req_local = '0' else '0';
  tmp_0179 <= tmp_0177 and tmp_0178;
  tmp_0180 <= '1' when tmp_0179 = '1' else '0';
  tmp_0181 <= '1' when pset_req_sig = '1' else '0';
  tmp_0182 <= '1' when pset_req_sig = '1' else '0';
  tmp_0183 <= pset_x_in_sig when tmp_0182 = '1' else pset_x;
  tmp_0184 <= '1' when pset_req_sig = '1' else '0';
  tmp_0185 <= '1' when pset_req_sig = '1' else '0';
  tmp_0186 <= pset_y_in_sig when tmp_0185 = '1' else pset_y;
  tmp_0187 <= '1' when pset_req_sig = '1' else '0';
  tmp_0188 <= '1' when pset_req_sig = '1' else '0';
  tmp_0189 <= pset_color_in_sig when tmp_0188 = '1' else pset_color;
  tmp_0190 <= clear_req_sig or clear_req_local;
  tmp_0191 <= X"00000438";
  tmp_0192 <= '1' when clear_i_1 < tmp_0191 else '0';
  tmp_0193 <= '1' when tmp_0192 = '0' else '0';
  tmp_0194 <= X"00000438";
  tmp_0195 <= '1' when clear_i_1 < tmp_0194 else '0';
  tmp_0196 <= '1' when tmp_0195 = '1' else '0';
  tmp_0197 <= X"00000780";
  tmp_0198 <= '1' when clear_j_0 < tmp_0197 else '0';
  tmp_0199 <= '1' when tmp_0198 = '0' else '0';
  tmp_0200 <= X"00000780";
  tmp_0201 <= '1' when clear_j_0 < tmp_0200 else '0';
  tmp_0202 <= '1' when tmp_0201 = '1' else '0';
  tmp_0203 <= '1' when S_clear = S_clear_IDLE else '0';
  tmp_0204 <= '0' when tmp_0203 = '1' else '1';
  tmp_0205 <= X"00000000";
  tmp_0206 <= X"00000000";
  tmp_0207 <= X"00000000";
  tmp_0209 <= '1' when pset_busy_sig = '0' else '0';
  tmp_0210 <= '1' when pset_req_local = '0' else '0';
  tmp_0211 <= tmp_0209 and tmp_0210;
  tmp_0212 <= '1' when tmp_0211 = '1' else '0';
  tmp_0213 <= clear_j_0 + 1;
  tmp_0214 <= clear_i_1 + 1;
  tmp_0215 <= fill_rect_req_sig or fill_rect_req_local;
  tmp_0216 <= '1' when fill_rect_i_6 < fill_rect_w else '0';
  tmp_0217 <= '1' when tmp_0216 = '0' else '0';
  tmp_0218 <= '1' when fill_rect_i_6 < fill_rect_w else '0';
  tmp_0219 <= '1' when tmp_0218 = '1' else '0';
  tmp_0220 <= '1' when fill_rect_j_5 < fill_rect_h else '0';
  tmp_0221 <= '1' when tmp_0220 = '0' else '0';
  tmp_0222 <= '1' when fill_rect_j_5 < fill_rect_h else '0';
  tmp_0223 <= '1' when tmp_0222 = '1' else '0';
  tmp_0224 <= '1' when S_fill_rect = S_fill_rect_IDLE else '0';
  tmp_0225 <= '0' when tmp_0224 = '1' else '1';
  tmp_0226 <= X"00000000";
  tmp_0227 <= X"00000000";
  tmp_0228 <= fill_rect_x + fill_rect_i_6;
  tmp_0229 <= fill_rect_y + fill_rect_j_5;
  tmp_0231 <= '1' when pset_busy_sig = '0' else '0';
  tmp_0232 <= '1' when pset_req_local = '0' else '0';
  tmp_0233 <= tmp_0231 and tmp_0232;
  tmp_0234 <= '1' when tmp_0233 = '1' else '0';
  tmp_0235 <= fill_rect_j_5 + 1;
  tmp_0236 <= fill_rect_i_6 + 1;
  tmp_0237 <= '1' when fill_rect_req_sig = '1' else '0';
  tmp_0238 <= '1' when fill_rect_req_sig = '1' else '0';
  tmp_0239 <= fill_rect_x_in_sig when tmp_0238 = '1' else fill_rect_x;
  tmp_0240 <= '1' when fill_rect_req_sig = '1' else '0';
  tmp_0241 <= '1' when fill_rect_req_sig = '1' else '0';
  tmp_0242 <= fill_rect_y_in_sig when tmp_0241 = '1' else fill_rect_y;
  tmp_0243 <= '1' when fill_rect_req_sig = '1' else '0';
  tmp_0244 <= '1' when fill_rect_req_sig = '1' else '0';
  tmp_0245 <= fill_rect_w_in_sig when tmp_0244 = '1' else fill_rect_w;
  tmp_0246 <= '1' when fill_rect_req_sig = '1' else '0';
  tmp_0247 <= '1' when fill_rect_req_sig = '1' else '0';
  tmp_0248 <= fill_rect_h_in_sig when tmp_0247 = '1' else fill_rect_h;
  tmp_0249 <= '1' when fill_rect_req_sig = '1' else '0';
  tmp_0250 <= '1' when fill_rect_req_sig = '1' else '0';
  tmp_0251 <= fill_rect_c_in_sig when tmp_0250 = '1' else fill_rect_c;
  tmp_0252 <= test_req_sig or test_req_local;
  tmp_0253 <= X"00000078";
  tmp_0254 <= '1' when test_i_1 < tmp_0253 else '0';
  tmp_0255 <= '1' when tmp_0254 = '0' else '0';
  tmp_0256 <= X"00000078";
  tmp_0257 <= '1' when test_i_1 < tmp_0256 else '0';
  tmp_0258 <= '1' when tmp_0257 = '1' else '0';
  tmp_0259 <= X"00000078";
  tmp_0260 <= '1' when test_j_0 < tmp_0259 else '0';
  tmp_0261 <= '1' when tmp_0260 = '0' else '0';
  tmp_0262 <= X"00000078";
  tmp_0263 <= '1' when test_j_0 < tmp_0262 else '0';
  tmp_0264 <= '1' when tmp_0263 = '1' else '0';
  tmp_0265 <= '1' when S_test = S_test_IDLE else '0';
  tmp_0266 <= '0' when tmp_0265 = '1' else '1';
  tmp_0267 <= X"0000001e";
  tmp_0268 <= X"0000001e";
  tmp_0269 <= X"00ff0000";
  tmp_0271 <= '1' when pset_busy_sig = '0' else '0';
  tmp_0272 <= '1' when pset_req_local = '0' else '0';
  tmp_0273 <= tmp_0271 and tmp_0272;
  tmp_0274 <= '1' when tmp_0273 = '1' else '0';
  tmp_0275 <= test_j_0 + 1;
  tmp_0276 <= test_i_1 + 1;
  tmp_0277 <= flush_req_sig or flush_req_local;
  tmp_0278 <= '1' when S_flush = S_flush_IDLE else '0';
  tmp_0279 <= '0' when tmp_0278 = '1' else '1';

  -- sequencers
  process (clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        S_set_color_0 <= S_set_color_0_IDLE;
        S_set_color_0_delay <= (others => '0');
      else
        case (S_set_color_0) is
          when S_set_color_0_IDLE => 
            if tmp_0001 = '1' then
              S_set_color_0 <= S_set_color_0_S_set_color_0_0005;
            end if;
          when S_set_color_0_S_set_color_0_0001 => 
            S_set_color_0 <= S_set_color_0_IDLE;
          when S_set_color_0_S_set_color_0_0002 => 
            if S_set_color_0_delay >= 1 and obj_write_data_busy_0015 = '1' then
              S_set_color_0_delay <= (others => '0');
              S_set_color_0 <= S_set_color_0_S_set_color_0_0001;
            else
              S_set_color_0_delay <= S_set_color_0_delay + 1;
            end if;
          when S_set_color_0_S_set_color_0_0003 => 
            S_set_color_0 <= S_set_color_0_S_set_color_0_0002;
          when S_set_color_0_S_set_color_0_0004 => 
            if S_set_color_0_delay >= 1 and obj_read_data_busy_0005 = '1' then
              S_set_color_0_delay <= (others => '0');
              S_set_color_0 <= S_set_color_0_S_set_color_0_0003;
            else
              S_set_color_0_delay <= S_set_color_0_delay + 1;
            end if;
          when S_set_color_0_S_set_color_0_0005 => 
            S_set_color_0 <= S_set_color_0_S_set_color_0_0004;
          when others => null;
        end case;
      end if;
    end if;
  end process;

  process (clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        S_set_color_1 <= S_set_color_1_IDLE;
        S_set_color_1_delay <= (others => '0');
      else
        case (S_set_color_1) is
          when S_set_color_1_IDLE => 
            if tmp_0020 = '1' then
              S_set_color_1 <= S_set_color_1_S_set_color_1_0005;
            end if;
          when S_set_color_1_S_set_color_1_0001 => 
            S_set_color_1 <= S_set_color_1_IDLE;
          when S_set_color_1_S_set_color_1_0002 => 
            if S_set_color_1_delay >= 1 and obj_write_data_busy_0036 = '1' then
              S_set_color_1_delay <= (others => '0');
              S_set_color_1 <= S_set_color_1_S_set_color_1_0001;
            else
              S_set_color_1_delay <= S_set_color_1_delay + 1;
            end if;
          when S_set_color_1_S_set_color_1_0003 => 
            S_set_color_1 <= S_set_color_1_S_set_color_1_0002;
          when S_set_color_1_S_set_color_1_0004 => 
            if S_set_color_1_delay >= 1 and obj_read_data_busy_0024 = '1' then
              S_set_color_1_delay <= (others => '0');
              S_set_color_1 <= S_set_color_1_S_set_color_1_0003;
            else
              S_set_color_1_delay <= S_set_color_1_delay + 1;
            end if;
          when S_set_color_1_S_set_color_1_0005 => 
            S_set_color_1 <= S_set_color_1_S_set_color_1_0004;
          when others => null;
        end case;
      end if;
    end if;
  end process;

  process (clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        S_set_color_2 <= S_set_color_2_IDLE;
        S_set_color_2_delay <= (others => '0');
      else
        case (S_set_color_2) is
          when S_set_color_2_IDLE => 
            if tmp_0041 = '1' then
              S_set_color_2 <= S_set_color_2_S_set_color_2_0008;
            end if;
          when S_set_color_2_S_set_color_2_0001 => 
            S_set_color_2 <= S_set_color_2_IDLE;
          when S_set_color_2_S_set_color_2_0002 => 
            if S_set_color_2_delay >= 1 and obj_write_data_busy_0078 = '1' then
              S_set_color_2_delay <= (others => '0');
              S_set_color_2 <= S_set_color_2_S_set_color_2_0001;
            else
              S_set_color_2_delay <= S_set_color_2_delay + 1;
            end if;
          when S_set_color_2_S_set_color_2_0003 => 
            S_set_color_2 <= S_set_color_2_S_set_color_2_0002;
          when S_set_color_2_S_set_color_2_0004 => 
            if S_set_color_2_delay >= 1 and obj_read_data_busy_0064 = '1' then
              S_set_color_2_delay <= (others => '0');
              S_set_color_2 <= S_set_color_2_S_set_color_2_0003;
            else
              S_set_color_2_delay <= S_set_color_2_delay + 1;
            end if;
          when S_set_color_2_S_set_color_2_0005 => 
            if S_set_color_2_delay >= 1 and obj_write_data_busy_0057 = '1' then
              S_set_color_2_delay <= (others => '0');
              S_set_color_2 <= S_set_color_2_S_set_color_2_0004;
            else
              S_set_color_2_delay <= S_set_color_2_delay + 1;
            end if;
          when S_set_color_2_S_set_color_2_0006 => 
            S_set_color_2 <= S_set_color_2_S_set_color_2_0005;
          when S_set_color_2_S_set_color_2_0007 => 
            if S_set_color_2_delay >= 1 and obj_read_data_busy_0045 = '1' then
              S_set_color_2_delay <= (others => '0');
              S_set_color_2 <= S_set_color_2_S_set_color_2_0006;
            else
              S_set_color_2_delay <= S_set_color_2_delay + 1;
            end if;
          when S_set_color_2_S_set_color_2_0008 => 
            S_set_color_2 <= S_set_color_2_S_set_color_2_0007;
          when others => null;
        end case;
      end if;
    end if;
  end process;

  process (clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        S_set_color_3 <= S_set_color_3_IDLE;
        S_set_color_3_delay <= (others => '0');
      else
        case (S_set_color_3) is
          when S_set_color_3_IDLE => 
            if tmp_0083 = '1' then
              S_set_color_3 <= S_set_color_3_S_set_color_3_0008;
            end if;
          when S_set_color_3_S_set_color_3_0001 => 
            S_set_color_3 <= S_set_color_3_IDLE;
          when S_set_color_3_S_set_color_3_0002 => 
            if S_set_color_3_delay >= 1 and obj_write_data_busy_0120 = '1' then
              S_set_color_3_delay <= (others => '0');
              S_set_color_3 <= S_set_color_3_S_set_color_3_0001;
            else
              S_set_color_3_delay <= S_set_color_3_delay + 1;
            end if;
          when S_set_color_3_S_set_color_3_0003 => 
            S_set_color_3 <= S_set_color_3_S_set_color_3_0002;
          when S_set_color_3_S_set_color_3_0004 => 
            if S_set_color_3_delay >= 1 and obj_read_data_busy_0106 = '1' then
              S_set_color_3_delay <= (others => '0');
              S_set_color_3 <= S_set_color_3_S_set_color_3_0003;
            else
              S_set_color_3_delay <= S_set_color_3_delay + 1;
            end if;
          when S_set_color_3_S_set_color_3_0005 => 
            if S_set_color_3_delay >= 1 and obj_write_data_busy_0099 = '1' then
              S_set_color_3_delay <= (others => '0');
              S_set_color_3 <= S_set_color_3_S_set_color_3_0004;
            else
              S_set_color_3_delay <= S_set_color_3_delay + 1;
            end if;
          when S_set_color_3_S_set_color_3_0006 => 
            S_set_color_3 <= S_set_color_3_S_set_color_3_0005;
          when S_set_color_3_S_set_color_3_0007 => 
            if S_set_color_3_delay >= 1 and obj_read_data_busy_0087 = '1' then
              S_set_color_3_delay <= (others => '0');
              S_set_color_3 <= S_set_color_3_S_set_color_3_0006;
            else
              S_set_color_3_delay <= S_set_color_3_delay + 1;
            end if;
          when S_set_color_3_S_set_color_3_0008 => 
            S_set_color_3 <= S_set_color_3_S_set_color_3_0007;
          when others => null;
        end case;
      end if;
    end if;
  end process;

  process (clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        S_pset <= S_pset_IDLE;
        S_pset_delay <= (others => '0');
      else
        case (S_pset) is
          when S_pset_IDLE => 
            if tmp_0125 = '1' then
              S_pset <= S_pset_S_pset_0018;
            end if;
          when S_pset_S_pset_0001 => 
            S_pset <= S_pset_IDLE;
          when S_pset_S_pset_0002 => 
            S_pset <= S_pset_S_pset_0001;
          when S_pset_S_pset_0003 => 
            S_pset <= S_pset_S_pset_0002;
          when S_pset_S_pset_0004 => 
            if S_pset_delay >= 1 and set_color_3_busy_sig_0176 = '1' then
              S_pset_delay <= (others => '0');
              S_pset <= S_pset_S_pset_0003;
            else
              S_pset_delay <= S_pset_delay + 1;
            end if;
          when S_pset_S_pset_0005 => 
            S_pset <= S_pset_S_pset_0002;
          when S_pset_S_pset_0006 => 
            if S_pset_delay >= 1 and set_color_2_busy_sig_0171 = '1' then
              S_pset_delay <= (others => '0');
              S_pset <= S_pset_S_pset_0005;
            else
              S_pset_delay <= S_pset_delay + 1;
            end if;
          when S_pset_S_pset_0007 => 
            S_pset <= S_pset_S_pset_0002;
          when S_pset_S_pset_0008 => 
            if S_pset_delay >= 1 and set_color_1_busy_sig_0166 = '1' then
              S_pset_delay <= (others => '0');
              S_pset <= S_pset_S_pset_0007;
            else
              S_pset_delay <= S_pset_delay + 1;
            end if;
          when S_pset_S_pset_0009 => 
            S_pset <= S_pset_S_pset_0002;
          when S_pset_S_pset_0010 => 
            if S_pset_delay >= 1 and set_color_0_busy_sig_0161 = '1' then
              S_pset_delay <= (others => '0');
              S_pset <= S_pset_S_pset_0009;
            else
              S_pset_delay <= S_pset_delay + 1;
            end if;
          when S_pset_S_pset_0011 => 
            if tmp_0127 = '1' then
              S_pset <= S_pset_S_pset_0010;
            elsif tmp_0129 = '1' then
              S_pset <= S_pset_S_pset_0008;
            elsif tmp_0131 = '1' then
              S_pset <= S_pset_S_pset_0006;
            elsif tmp_0133 = '1' then
              S_pset <= S_pset_S_pset_0004;
            else
              S_pset <= S_pset_S_pset_0012;
            end if;
          when S_pset_S_pset_0012 => 
            S_pset <= S_pset_S_pset_0002;
          when S_pset_S_pset_0014 => 
            S_pset <= S_pset_S_pset_0011;
          when S_pset_S_pset_0016 => 
            S_pset <= S_pset_S_pset_0014;
          when S_pset_S_pset_0018 => 
            S_pset <= S_pset_S_pset_0016;
          when others => null;
        end case;
      end if;
    end if;
  end process;

  process (clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        S_clear <= S_clear_IDLE;
        S_clear_delay <= (others => '0');
      else
        case (S_clear) is
          when S_clear_IDLE => 
            if tmp_0190 = '1' then
              S_clear <= S_clear_S_clear_0008;
            end if;
          when S_clear_S_clear_0001 => 
            S_clear <= S_clear_IDLE;
          when S_clear_S_clear_0002 => 
            if tmp_0193 = '1' then
              S_clear <= S_clear_S_clear_0001;
            elsif tmp_0196 = '1' then
              S_clear <= S_clear_S_clear_0007;
            end if;
          when S_clear_S_clear_0003 => 
            S_clear <= S_clear_S_clear_0002;
          when S_clear_S_clear_0004 => 
            if tmp_0199 = '1' then
              S_clear <= S_clear_S_clear_0003;
            elsif tmp_0202 = '1' then
              S_clear <= S_clear_S_clear_0006;
            end if;
          when S_clear_S_clear_0005 => 
            S_clear <= S_clear_S_clear_0004;
          when S_clear_S_clear_0006 => 
            if S_clear_delay >= 1 and pset_busy_sig_0208 = '1' then
              S_clear_delay <= (others => '0');
              S_clear <= S_clear_S_clear_0005;
            else
              S_clear_delay <= S_clear_delay + 1;
            end if;
          when S_clear_S_clear_0007 => 
            S_clear <= S_clear_S_clear_0004;
          when S_clear_S_clear_0008 => 
            S_clear <= S_clear_S_clear_0002;
          when others => null;
        end case;
      end if;
    end if;
  end process;

  process (clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        S_fill_rect <= S_fill_rect_IDLE;
        S_fill_rect_delay <= (others => '0');
      else
        case (S_fill_rect) is
          when S_fill_rect_IDLE => 
            if tmp_0215 = '1' then
              S_fill_rect <= S_fill_rect_S_fill_rect_0008;
            end if;
          when S_fill_rect_S_fill_rect_0001 => 
            S_fill_rect <= S_fill_rect_IDLE;
          when S_fill_rect_S_fill_rect_0002 => 
            if tmp_0217 = '1' then
              S_fill_rect <= S_fill_rect_S_fill_rect_0001;
            elsif tmp_0219 = '1' then
              S_fill_rect <= S_fill_rect_S_fill_rect_0007;
            end if;
          when S_fill_rect_S_fill_rect_0003 => 
            S_fill_rect <= S_fill_rect_S_fill_rect_0002;
          when S_fill_rect_S_fill_rect_0004 => 
            if tmp_0221 = '1' then
              S_fill_rect <= S_fill_rect_S_fill_rect_0003;
            elsif tmp_0223 = '1' then
              S_fill_rect <= S_fill_rect_S_fill_rect_0006;
            end if;
          when S_fill_rect_S_fill_rect_0005 => 
            S_fill_rect <= S_fill_rect_S_fill_rect_0004;
          when S_fill_rect_S_fill_rect_0006 => 
            if S_fill_rect_delay >= 1 and pset_busy_sig_0230 = '1' then
              S_fill_rect_delay <= (others => '0');
              S_fill_rect <= S_fill_rect_S_fill_rect_0005;
            else
              S_fill_rect_delay <= S_fill_rect_delay + 1;
            end if;
          when S_fill_rect_S_fill_rect_0007 => 
            S_fill_rect <= S_fill_rect_S_fill_rect_0004;
          when S_fill_rect_S_fill_rect_0008 => 
            S_fill_rect <= S_fill_rect_S_fill_rect_0002;
          when others => null;
        end case;
      end if;
    end if;
  end process;

  process (clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        S_test <= S_test_IDLE;
        S_test_delay <= (others => '0');
      else
        case (S_test) is
          when S_test_IDLE => 
            if tmp_0252 = '1' then
              S_test <= S_test_S_test_0008;
            end if;
          when S_test_S_test_0001 => 
            S_test <= S_test_IDLE;
          when S_test_S_test_0002 => 
            if tmp_0255 = '1' then
              S_test <= S_test_S_test_0001;
            elsif tmp_0258 = '1' then
              S_test <= S_test_S_test_0007;
            end if;
          when S_test_S_test_0003 => 
            S_test <= S_test_S_test_0002;
          when S_test_S_test_0004 => 
            if tmp_0261 = '1' then
              S_test <= S_test_S_test_0003;
            elsif tmp_0264 = '1' then
              S_test <= S_test_S_test_0006;
            end if;
          when S_test_S_test_0005 => 
            S_test <= S_test_S_test_0004;
          when S_test_S_test_0006 => 
            if S_test_delay >= 1 and pset_busy_sig_0270 = '1' then
              S_test_delay <= (others => '0');
              S_test <= S_test_S_test_0005;
            else
              S_test_delay <= S_test_delay + 1;
            end if;
          when S_test_S_test_0007 => 
            S_test <= S_test_S_test_0004;
          when S_test_S_test_0008 => 
            S_test <= S_test_S_test_0002;
          when others => null;
        end case;
      end if;
    end if;
  end process;

  process (clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        S_flush <= S_flush_IDLE;
        S_flush_delay <= (others => '0');
      else
        case (S_flush) is
          when S_flush_IDLE => 
            if tmp_0277 = '1' then
              S_flush <= S_flush_S_flush_0001;
            end if;
          when S_flush_S_flush_0001 => 
            S_flush <= S_flush_IDLE;
          when others => null;
        end case;
      end if;
    end if;
  end process;


  obj_clk <= clk_sig;

  obj_reset <= reset_sig;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        obj_write_data_addr_in <= (others => '0');
      else
        if S_set_color_0 = S_set_color_0_S_set_color_0_0002 and S_set_color_0_delay = 0 then
          obj_write_data_addr_in <= set_color_0_base;
        elsif S_set_color_1 = S_set_color_1_S_set_color_1_0002 and S_set_color_1_delay = 0 then
          obj_write_data_addr_in <= set_color_1_base;
        elsif S_set_color_2 = S_set_color_2_S_set_color_2_0005 and S_set_color_2_delay = 0 then
          obj_write_data_addr_in <= set_color_2_base;
        elsif S_set_color_2 = S_set_color_2_S_set_color_2_0002 and S_set_color_2_delay = 0 then
          obj_write_data_addr_in <= tmp_0077;
        elsif S_set_color_3 = S_set_color_3_S_set_color_3_0005 and S_set_color_3_delay = 0 then
          obj_write_data_addr_in <= set_color_3_base;
        elsif S_set_color_3 = S_set_color_3_S_set_color_3_0002 and S_set_color_3_delay = 0 then
          obj_write_data_addr_in <= tmp_0119;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        obj_write_data_data_in <= (others => '0');
      else
        if S_set_color_0 = S_set_color_0_S_set_color_0_0002 and S_set_color_0_delay = 0 then
          obj_write_data_data_in <= set_color_0_v_2;
        elsif S_set_color_1 = S_set_color_1_S_set_color_1_0002 and S_set_color_1_delay = 0 then
          obj_write_data_data_in <= set_color_1_v_2;
        elsif S_set_color_2 = S_set_color_2_S_set_color_2_0005 and S_set_color_2_delay = 0 then
          obj_write_data_data_in <= set_color_2_v_2;
        elsif S_set_color_2 = S_set_color_2_S_set_color_2_0002 and S_set_color_2_delay = 0 then
          obj_write_data_data_in <= set_color_2_v_2;
        elsif S_set_color_3 = S_set_color_3_S_set_color_3_0005 and S_set_color_3_delay = 0 then
          obj_write_data_data_in <= set_color_3_v_2;
        elsif S_set_color_3 = S_set_color_3_S_set_color_3_0002 and S_set_color_3_delay = 0 then
          obj_write_data_data_in <= set_color_3_v_2;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        obj_write_data_req <= '0';
      else
        if S_set_color_0 = S_set_color_0_S_set_color_0_0002 and S_set_color_0_delay = 0 then
          obj_write_data_req <= '1';
        elsif S_set_color_1 = S_set_color_1_S_set_color_1_0002 and S_set_color_1_delay = 0 then
          obj_write_data_req <= '1';
        elsif S_set_color_2 = S_set_color_2_S_set_color_2_0005 and S_set_color_2_delay = 0 then
          obj_write_data_req <= '1';
        elsif S_set_color_2 = S_set_color_2_S_set_color_2_0002 and S_set_color_2_delay = 0 then
          obj_write_data_req <= '1';
        elsif S_set_color_3 = S_set_color_3_S_set_color_3_0005 and S_set_color_3_delay = 0 then
          obj_write_data_req <= '1';
        elsif S_set_color_3 = S_set_color_3_S_set_color_3_0002 and S_set_color_3_delay = 0 then
          obj_write_data_req <= '1';
        else
          obj_write_data_req <= '0';
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        obj_read_data_addr_in <= (others => '0');
      else
        if S_set_color_0 = S_set_color_0_S_set_color_0_0004 and S_set_color_0_delay = 0 then
          obj_read_data_addr_in <= set_color_0_base;
        elsif S_set_color_1 = S_set_color_1_S_set_color_1_0004 and S_set_color_1_delay = 0 then
          obj_read_data_addr_in <= set_color_1_base;
        elsif S_set_color_2 = S_set_color_2_S_set_color_2_0007 and S_set_color_2_delay = 0 then
          obj_read_data_addr_in <= set_color_2_base;
        elsif S_set_color_2 = S_set_color_2_S_set_color_2_0004 and S_set_color_2_delay = 0 then
          obj_read_data_addr_in <= tmp_0063;
        elsif S_set_color_3 = S_set_color_3_S_set_color_3_0007 and S_set_color_3_delay = 0 then
          obj_read_data_addr_in <= set_color_3_base;
        elsif S_set_color_3 = S_set_color_3_S_set_color_3_0004 and S_set_color_3_delay = 0 then
          obj_read_data_addr_in <= tmp_0105;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        obj_read_data_req <= '0';
      else
        if S_set_color_0 = S_set_color_0_S_set_color_0_0004 and S_set_color_0_delay = 0 then
          obj_read_data_req <= '1';
        elsif S_set_color_1 = S_set_color_1_S_set_color_1_0004 and S_set_color_1_delay = 0 then
          obj_read_data_req <= '1';
        elsif S_set_color_2 = S_set_color_2_S_set_color_2_0007 and S_set_color_2_delay = 0 then
          obj_read_data_req <= '1';
        elsif S_set_color_2 = S_set_color_2_S_set_color_2_0004 and S_set_color_2_delay = 0 then
          obj_read_data_req <= '1';
        elsif S_set_color_3 = S_set_color_3_S_set_color_3_0007 and S_set_color_3_delay = 0 then
          obj_read_data_req <= '1';
        elsif S_set_color_3 = S_set_color_3_S_set_color_3_0004 and S_set_color_3_delay = 0 then
          obj_read_data_req <= '1';
        else
          obj_read_data_req <= '0';
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        clear_i_1 <= X"00000000";
      else
        if S_clear = S_clear_S_clear_0008 then
          clear_i_1 <= tmp_0205;
        elsif S_clear = S_clear_S_clear_0003 then
          clear_i_1 <= tmp_0214;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        clear_j_0 <= X"00000000";
      else
        if S_clear = S_clear_S_clear_0007 then
          clear_j_0 <= tmp_0206;
        elsif S_clear = S_clear_S_clear_0005 then
          clear_j_0 <= tmp_0213;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        fill_rect_i_6 <= X"00000000";
      else
        if S_fill_rect = S_fill_rect_S_fill_rect_0008 then
          fill_rect_i_6 <= tmp_0226;
        elsif S_fill_rect = S_fill_rect_S_fill_rect_0003 then
          fill_rect_i_6 <= tmp_0236;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        fill_rect_j_5 <= X"00000000";
      else
        if S_fill_rect = S_fill_rect_S_fill_rect_0007 then
          fill_rect_j_5 <= tmp_0227;
        elsif S_fill_rect = S_fill_rect_S_fill_rect_0005 then
          fill_rect_j_5 <= tmp_0235;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        test_i_1 <= X"0000001e";
      else
        if S_test = S_test_S_test_0008 then
          test_i_1 <= tmp_0267;
        elsif S_test = S_test_S_test_0003 then
          test_i_1 <= tmp_0276;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        test_j_0 <= X"0000001e";
      else
        if S_test = S_test_S_test_0007 then
          test_j_0 <= tmp_0268;
        elsif S_test = S_test_S_test_0005 then
          test_j_0 <= tmp_0275;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        set_color_0_base <= (others => '0');
      else
        if S_pset = S_pset_S_pset_0010 and S_pset_delay = 0 then
          set_color_0_base <= pset_base_3;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        set_color_0_color <= (others => '0');
      else
        if S_pset = S_pset_S_pset_0010 and S_pset_delay = 0 then
          set_color_0_color <= pset_color;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        set_color_0_req_local <= '0';
      else
        if S_pset = S_pset_S_pset_0010 and S_pset_delay = 0 then
          set_color_0_req_local <= '1';
        else
          set_color_0_req_local <= '0';
        end if;
      end if;
    end if;
  end process;

  set_color_0_busy_sig <= tmp_0003;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        set_color_0_v_2 <= X"00000000";
      else
        if S_set_color_0 = S_set_color_0_S_set_color_0_0005 then
          set_color_0_v_2 <= tmp_0004;
        elsif S_set_color_0 = S_set_color_0_S_set_color_0_0004 and S_set_color_0_delay >= 1 and obj_read_data_busy_0005 = '1' then
          set_color_0_v_2 <= obj_read_data_return;
        elsif S_set_color_0 = S_set_color_0_S_set_color_0_0003 then
          set_color_0_v_2 <= tmp_0014;
        end if;
      end if;
    end if;
  end process;

  obj_read_data_busy_0005 <= tmp_0009;

  obj_write_data_busy_0015 <= tmp_0019;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        set_color_1_base <= (others => '0');
      else
        if S_pset = S_pset_S_pset_0008 and S_pset_delay = 0 then
          set_color_1_base <= pset_base_3;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        set_color_1_color <= (others => '0');
      else
        if S_pset = S_pset_S_pset_0008 and S_pset_delay = 0 then
          set_color_1_color <= pset_color;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        set_color_1_req_local <= '0';
      else
        if S_pset = S_pset_S_pset_0008 and S_pset_delay = 0 then
          set_color_1_req_local <= '1';
        else
          set_color_1_req_local <= '0';
        end if;
      end if;
    end if;
  end process;

  set_color_1_busy_sig <= tmp_0022;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        set_color_1_v_2 <= X"00000000";
      else
        if S_set_color_1 = S_set_color_1_S_set_color_1_0005 then
          set_color_1_v_2 <= tmp_0023;
        elsif S_set_color_1 = S_set_color_1_S_set_color_1_0004 and S_set_color_1_delay >= 1 and obj_read_data_busy_0024 = '1' then
          set_color_1_v_2 <= obj_read_data_return;
        elsif S_set_color_1 = S_set_color_1_S_set_color_1_0003 then
          set_color_1_v_2 <= tmp_0035;
        end if;
      end if;
    end if;
  end process;

  obj_read_data_busy_0024 <= tmp_0028;

  obj_write_data_busy_0036 <= tmp_0040;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        set_color_2_base <= (others => '0');
      else
        if S_pset = S_pset_S_pset_0006 and S_pset_delay = 0 then
          set_color_2_base <= pset_base_3;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        set_color_2_color <= (others => '0');
      else
        if S_pset = S_pset_S_pset_0006 and S_pset_delay = 0 then
          set_color_2_color <= pset_color;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        set_color_2_req_local <= '0';
      else
        if S_pset = S_pset_S_pset_0006 and S_pset_delay = 0 then
          set_color_2_req_local <= '1';
        else
          set_color_2_req_local <= '0';
        end if;
      end if;
    end if;
  end process;

  set_color_2_busy_sig <= tmp_0043;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        set_color_2_v_2 <= X"00000000";
      else
        if S_set_color_2 = S_set_color_2_S_set_color_2_0008 then
          set_color_2_v_2 <= tmp_0044;
        elsif S_set_color_2 = S_set_color_2_S_set_color_2_0007 and S_set_color_2_delay >= 1 and obj_read_data_busy_0045 = '1' then
          set_color_2_v_2 <= obj_read_data_return;
        elsif S_set_color_2 = S_set_color_2_S_set_color_2_0006 then
          set_color_2_v_2 <= tmp_0056;
        elsif S_set_color_2 = S_set_color_2_S_set_color_2_0004 and S_set_color_2_delay >= 1 and obj_read_data_busy_0064 = '1' then
          set_color_2_v_2 <= obj_read_data_return;
        elsif S_set_color_2 = S_set_color_2_S_set_color_2_0003 then
          set_color_2_v_2 <= tmp_0075;
        end if;
      end if;
    end if;
  end process;

  obj_read_data_busy_0045 <= tmp_0049;

  obj_write_data_busy_0057 <= tmp_0061;

  obj_read_data_busy_0064 <= tmp_0068;

  obj_write_data_busy_0078 <= tmp_0082;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        set_color_3_base <= (others => '0');
      else
        if S_pset = S_pset_S_pset_0004 and S_pset_delay = 0 then
          set_color_3_base <= pset_base_3;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        set_color_3_color <= (others => '0');
      else
        if S_pset = S_pset_S_pset_0004 and S_pset_delay = 0 then
          set_color_3_color <= pset_color;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        set_color_3_req_local <= '0';
      else
        if S_pset = S_pset_S_pset_0004 and S_pset_delay = 0 then
          set_color_3_req_local <= '1';
        else
          set_color_3_req_local <= '0';
        end if;
      end if;
    end if;
  end process;

  set_color_3_busy_sig <= tmp_0085;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        set_color_3_v_2 <= X"00000000";
      else
        if S_set_color_3 = S_set_color_3_S_set_color_3_0008 then
          set_color_3_v_2 <= tmp_0086;
        elsif S_set_color_3 = S_set_color_3_S_set_color_3_0007 and S_set_color_3_delay >= 1 and obj_read_data_busy_0087 = '1' then
          set_color_3_v_2 <= obj_read_data_return;
        elsif S_set_color_3 = S_set_color_3_S_set_color_3_0006 then
          set_color_3_v_2 <= tmp_0098;
        elsif S_set_color_3 = S_set_color_3_S_set_color_3_0004 and S_set_color_3_delay >= 1 and obj_read_data_busy_0106 = '1' then
          set_color_3_v_2 <= obj_read_data_return;
        elsif S_set_color_3 = S_set_color_3_S_set_color_3_0003 then
          set_color_3_v_2 <= tmp_0117;
        end if;
      end if;
    end if;
  end process;

  obj_read_data_busy_0087 <= tmp_0091;

  obj_write_data_busy_0099 <= tmp_0103;

  obj_read_data_busy_0106 <= tmp_0110;

  obj_write_data_busy_0120 <= tmp_0124;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        pset_x <= (others => '0');
      else
        if S_pset = S_pset_IDLE and tmp_0181 = '1' then
          pset_x <= tmp_0183;
        elsif S_clear = S_clear_S_clear_0006 and S_clear_delay = 0 then
          pset_x <= clear_i_1;
        elsif S_fill_rect = S_fill_rect_S_fill_rect_0006 and S_fill_rect_delay = 0 then
          pset_x <= tmp_0228;
        elsif S_test = S_test_S_test_0006 and S_test_delay = 0 then
          pset_x <= test_i_1;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        pset_y <= (others => '0');
      else
        if S_pset = S_pset_IDLE and tmp_0184 = '1' then
          pset_y <= tmp_0186;
        elsif S_clear = S_clear_S_clear_0006 and S_clear_delay = 0 then
          pset_y <= clear_j_0;
        elsif S_fill_rect = S_fill_rect_S_fill_rect_0006 and S_fill_rect_delay = 0 then
          pset_y <= tmp_0229;
        elsif S_test = S_test_S_test_0006 and S_test_delay = 0 then
          pset_y <= test_j_0;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        pset_color <= (others => '0');
      else
        if S_pset = S_pset_IDLE and tmp_0187 = '1' then
          pset_color <= tmp_0189;
        elsif S_clear = S_clear_S_clear_0006 and S_clear_delay = 0 then
          pset_color <= tmp_0207;
        elsif S_fill_rect = S_fill_rect_S_fill_rect_0006 and S_fill_rect_delay = 0 then
          pset_color <= fill_rect_c;
        elsif S_test = S_test_S_test_0006 and S_test_delay = 0 then
          pset_color <= tmp_0269;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        pset_req_local <= '0';
      else
        if S_clear = S_clear_S_clear_0006 and S_clear_delay = 0 then
          pset_req_local <= '1';
        elsif S_fill_rect = S_fill_rect_S_fill_rect_0006 and S_fill_rect_delay = 0 then
          pset_req_local <= '1';
        elsif S_test = S_test_S_test_0006 and S_test_delay = 0 then
          pset_req_local <= '1';
        else
          pset_req_local <= '0';
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        pset_idx_4 <= (others => '0');
      else
        if S_pset = S_pset_S_pset_0016 then
          pset_idx_4 <= tmp_0158;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        pset_v_7 <= X"00000000";
      else
        if S_pset = S_pset_S_pset_0018 then
          pset_v_7 <= tmp_0160;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        pset_base_3 <= (others => '0');
      else
        if S_pset = S_pset_S_pset_0016 then
          pset_base_3 <= tmp_0153;
        elsif S_pset = S_pset_S_pset_0014 then
          pset_base_3 <= tmp_0159;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        pset_pt_6 <= (others => '0');
      else
        if S_pset = S_pset_S_pset_0018 then
          pset_pt_6 <= tmp_0148;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        pset_offset_5 <= X"3f000000";
      else
        if S_pset = S_pset_S_pset_0018 then
          pset_offset_5 <= tmp_0136;
        end if;
      end if;
    end if;
  end process;

  set_color_0_busy_sig_0161 <= tmp_0165;

  set_color_1_busy_sig_0166 <= tmp_0170;

  set_color_2_busy_sig_0171 <= tmp_0175;

  set_color_3_busy_sig_0176 <= tmp_0180;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        clear_req_local <= '0';
      else
        clear_req_local <= '0';
      end if;
    end if;
  end process;

  pset_busy_sig_0208 <= tmp_0212;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        fill_rect_x <= (others => '0');
      else
        if S_fill_rect = S_fill_rect_IDLE and tmp_0237 = '1' then
          fill_rect_x <= tmp_0239;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        fill_rect_y <= (others => '0');
      else
        if S_fill_rect = S_fill_rect_IDLE and tmp_0240 = '1' then
          fill_rect_y <= tmp_0242;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        fill_rect_w <= (others => '0');
      else
        if S_fill_rect = S_fill_rect_IDLE and tmp_0243 = '1' then
          fill_rect_w <= tmp_0245;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        fill_rect_h <= (others => '0');
      else
        if S_fill_rect = S_fill_rect_IDLE and tmp_0246 = '1' then
          fill_rect_h <= tmp_0248;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        fill_rect_c <= (others => '0');
      else
        if S_fill_rect = S_fill_rect_IDLE and tmp_0249 = '1' then
          fill_rect_c <= tmp_0251;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        fill_rect_req_local <= '0';
      else
        fill_rect_req_local <= '0';
      end if;
    end if;
  end process;

  pset_busy_sig_0230 <= tmp_0234;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        test_req_local <= '0';
      else
        test_req_local <= '0';
      end if;
    end if;
  end process;

  pset_busy_sig_0270 <= tmp_0274;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        flush_req_local <= '0';
      else
        flush_req_local <= '0';
      end if;
    end if;
  end process;


  inst_obj : synthesijer_lib_axi_SimpleAXIMemIface32RTLTest
  port map(
    clk => obj_clk,
    reset => obj_reset,
    write_data_addr_in => obj_write_data_addr_in,
    write_data_data_in => obj_write_data_data_in,
    write_data_req => obj_write_data_req,
    write_data_busy => obj_write_data_busy,
    read_data_addr_in => obj_read_data_addr_in,
    read_data_return => obj_read_data_return,
    read_data_req => obj_read_data_req,
    read_data_busy => obj_read_data_busy,
    test_req => obj_test_req,
    test_busy => obj_test_busy,
    obj_forbid => obj_obj_forbid,
    obj_axi_reader_ARADDR => obj_obj_axi_reader_ARADDR,
    obj_axi_reader_ARLEN => obj_obj_axi_reader_ARLEN,
    obj_axi_reader_ARVALID => obj_obj_axi_reader_ARVALID,
    obj_axi_reader_ARREADY => obj_obj_axi_reader_ARREADY,
    obj_axi_reader_ARSIZE => obj_obj_axi_reader_ARSIZE,
    obj_axi_reader_ARBURST => obj_obj_axi_reader_ARBURST,
    obj_axi_reader_ARCACHE => obj_obj_axi_reader_ARCACHE,
    obj_axi_reader_ARPROT => obj_obj_axi_reader_ARPROT,
    obj_axi_reader_RDATA => obj_obj_axi_reader_RDATA,
    obj_axi_reader_RRESP => obj_obj_axi_reader_RRESP,
    obj_axi_reader_RLAST => obj_obj_axi_reader_RLAST,
    obj_axi_reader_RVALID => obj_obj_axi_reader_RVALID,
    obj_axi_reader_RREADY => obj_obj_axi_reader_RREADY,
    obj_axi_writer_AWADDR => obj_obj_axi_writer_AWADDR,
    obj_axi_writer_AWLEN => obj_obj_axi_writer_AWLEN,
    obj_axi_writer_AWVALID => obj_obj_axi_writer_AWVALID,
    obj_axi_writer_AWSIZE => obj_obj_axi_writer_AWSIZE,
    obj_axi_writer_AWBURST => obj_obj_axi_writer_AWBURST,
    obj_axi_writer_AWCACHE => obj_obj_axi_writer_AWCACHE,
    obj_axi_writer_AWPROT => obj_obj_axi_writer_AWPROT,
    obj_axi_writer_AWREADY => obj_obj_axi_writer_AWREADY,
    obj_axi_writer_WDATA => obj_obj_axi_writer_WDATA,
    obj_axi_writer_WLAST => obj_obj_axi_writer_WLAST,
    obj_axi_writer_WVALID => obj_obj_axi_writer_WVALID,
    obj_axi_writer_WREADY => obj_obj_axi_writer_WREADY,
    obj_axi_writer_WSTRB => obj_obj_axi_writer_WSTRB,
    obj_axi_writer_BRESP => obj_obj_axi_writer_BRESP,
    obj_axi_writer_BVALID => obj_obj_axi_writer_BVALID,
    obj_axi_writer_BREADY => obj_obj_axi_writer_BREADY
  );


end RTL;
