library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity synthesijer_lib_axi_SimpleAXIMemIface32RTLTest is
  port (
    clk : in std_logic;
    reset : in std_logic;
    obj_forbid : in std_logic;
    obj_axi_reader_ARADDR : out std_logic_vector(32-1 downto 0);
    obj_axi_reader_ARLEN : out std_logic_vector(8-1 downto 0);
    obj_axi_reader_ARVALID : out std_logic;
    obj_axi_reader_ARREADY : in std_logic;
    obj_axi_reader_ARSIZE : out std_logic_vector(3-1 downto 0);
    obj_axi_reader_ARBURST : out std_logic_vector(2-1 downto 0);
    obj_axi_reader_ARCACHE : out std_logic_vector(4-1 downto 0);
    obj_axi_reader_ARPROT : out std_logic_vector(3-1 downto 0);
    obj_axi_reader_RDATA : in std_logic_vector(32-1 downto 0);
    obj_axi_reader_RRESP : in std_logic_vector(2-1 downto 0);
    obj_axi_reader_RLAST : in std_logic;
    obj_axi_reader_RVALID : in std_logic;
    obj_axi_reader_RREADY : out std_logic;
    obj_axi_writer_AWADDR : out std_logic_vector(32-1 downto 0);
    obj_axi_writer_AWLEN : out std_logic_vector(8-1 downto 0);
    obj_axi_writer_AWVALID : out std_logic;
    obj_axi_writer_AWSIZE : out std_logic_vector(3-1 downto 0);
    obj_axi_writer_AWBURST : out std_logic_vector(2-1 downto 0);
    obj_axi_writer_AWCACHE : out std_logic_vector(4-1 downto 0);
    obj_axi_writer_AWPROT : out std_logic_vector(3-1 downto 0);
    obj_axi_writer_AWREADY : in std_logic;
    obj_axi_writer_WDATA : out std_logic_vector(32-1 downto 0);
    obj_axi_writer_WLAST : out std_logic;
    obj_axi_writer_WVALID : out std_logic;
    obj_axi_writer_WREADY : in std_logic;
    obj_axi_writer_WSTRB : out std_logic_vector(4-1 downto 0);
    obj_axi_writer_BRESP : in std_logic_vector(2-1 downto 0);
    obj_axi_writer_BVALID : in std_logic;
    obj_axi_writer_BREADY : out std_logic;
    write_data_addr_in : in signed(32-1 downto 0);
    write_data_data_in : in signed(32-1 downto 0);
    write_data_req : in std_logic;
    write_data_busy : out std_logic;
    read_data_addr_in : in signed(32-1 downto 0);
    read_data_return : out signed(32-1 downto 0);
    read_data_req : in std_logic;
    read_data_busy : out std_logic;
    test_req : in std_logic;
    test_busy : out std_logic
  );
end synthesijer_lib_axi_SimpleAXIMemIface32RTLTest;

architecture RTL of synthesijer_lib_axi_SimpleAXIMemIface32RTLTest is

  component simple_axi_memiface_32
    port (
      clk : in std_logic;
      reset : in std_logic;
      data_address : in std_logic_vector(32-1 downto 0);
      data_din : in std_logic_vector(32-1 downto 0);
      data_dout : out std_logic_vector(32-1 downto 0);
      read_result : out std_logic_vector(32-1 downto 0);
      data_we : in std_logic;
      data_oe : in std_logic;
      data_length : out std_logic_vector(32-1 downto 0);
      busy : out std_logic;
      forbid : in std_logic;
      axi_reader_ARADDR : out std_logic_vector(32-1 downto 0);
      axi_reader_ARLEN : out std_logic_vector(8-1 downto 0);
      axi_reader_ARVALID : out std_logic;
      axi_reader_ARREADY : in std_logic;
      axi_reader_ARSIZE : out std_logic_vector(3-1 downto 0);
      axi_reader_ARBURST : out std_logic_vector(2-1 downto 0);
      axi_reader_ARCACHE : out std_logic_vector(4-1 downto 0);
      axi_reader_ARPROT : out std_logic_vector(3-1 downto 0);
      axi_reader_RDATA : in std_logic_vector(32-1 downto 0);
      axi_reader_RRESP : in std_logic_vector(2-1 downto 0);
      axi_reader_RLAST : in std_logic;
      axi_reader_RVALID : in std_logic;
      axi_reader_RREADY : out std_logic;
      axi_writer_AWADDR : out std_logic_vector(32-1 downto 0);
      axi_writer_AWLEN : out std_logic_vector(8-1 downto 0);
      axi_writer_AWVALID : out std_logic;
      axi_writer_AWSIZE : out std_logic_vector(3-1 downto 0);
      axi_writer_AWBURST : out std_logic_vector(2-1 downto 0);
      axi_writer_AWCACHE : out std_logic_vector(4-1 downto 0);
      axi_writer_AWPROT : out std_logic_vector(3-1 downto 0);
      axi_writer_AWREADY : in std_logic;
      axi_writer_WDATA : out std_logic_vector(32-1 downto 0);
      axi_writer_WLAST : out std_logic;
      axi_writer_WVALID : out std_logic;
      axi_writer_WREADY : in std_logic;
      axi_writer_WSTRB : out std_logic_vector(4-1 downto 0);
      axi_writer_BRESP : in std_logic_vector(2-1 downto 0);
      axi_writer_BVALID : in std_logic;
      axi_writer_BREADY : out std_logic
    );
  end component simple_axi_memiface_32;

  signal clk_sig : std_logic;
  signal reset_sig : std_logic;
  signal write_data_addr_in_sig : signed(32-1 downto 0);
  signal write_data_data_in_sig : signed(32-1 downto 0);
  signal write_data_req_sig : std_logic;
  signal write_data_busy_sig : std_logic;
  signal read_data_addr_in_sig : signed(32-1 downto 0);
  signal read_data_return_sig : signed(32-1 downto 0) := (others => '0');
  signal read_data_req_sig : std_logic;
  signal read_data_busy_sig : std_logic;
  signal test_req_sig : std_logic;
  signal test_busy_sig : std_logic;

  signal obj_clk : std_logic;
  signal obj_reset : std_logic;
  signal obj_data_address : std_logic_vector(32-1 downto 0) := (others => '0');
  signal obj_data_din : std_logic_vector(32-1 downto 0) := (others => '0');
  signal obj_data_dout : std_logic_vector(32-1 downto 0);
  signal obj_read_result : std_logic_vector(32-1 downto 0);
  signal obj_data_we : std_logic := '0';
  signal obj_data_oe : std_logic := '0';
  signal obj_data_length : std_logic_vector(32-1 downto 0);
  signal obj_busy : std_logic;
  signal test_j_4 : signed(32-1 downto 0) := X"00000078";
  signal test_y_1 : signed(32-1 downto 0) := (others => '0');
  signal test_i_2 : signed(32-1 downto 0) := X"00000000";
  signal test_pt_0 : signed(32-1 downto 0) := (others => '0');
  type Type_methodId is (
    IDLE,
    method_write_data,
    method_read_data,
    method_test  
  );
  signal methodId : Type_methodId := IDLE;
  signal write_data_addr : signed(32-1 downto 0) := (others => '0');
  signal write_data_data : signed(32-1 downto 0) := (others => '0');
  signal write_data_req_local : std_logic := '0';
  signal tmp_0001 : std_logic;
  type Type_S_write_data is (
    S_write_data_IDLE,
    S_write_data_S_write_data_0001,
    S_write_data_S_write_data_0002,
    S_write_data_S_write_data_0003  
  );
  signal S_write_data : Type_S_write_data := S_write_data_IDLE;
  signal S_write_data_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0002 : std_logic;
  signal tmp_0003 : std_logic;
  signal tmp_0004 : std_logic;
  signal tmp_0005 : std_logic;
  signal tmp_0006 : std_logic;
  signal tmp_0007 : std_logic;
  signal tmp_0008 : std_logic;
  signal tmp_0009 : std_logic;
  signal tmp_0010 : std_logic;
  signal tmp_0011 : std_logic;
  signal tmp_0012 : signed(32-1 downto 0);
  signal tmp_0013 : std_logic;
  signal tmp_0014 : std_logic;
  signal tmp_0015 : signed(32-1 downto 0);
  signal read_data_addr : signed(32-1 downto 0) := (others => '0');
  signal read_data_req_local : std_logic := '0';
  signal tmp_0016 : std_logic;
  signal read_data_v_1 : signed(32-1 downto 0) := (others => '0');
  type Type_S_read_data is (
    S_read_data_IDLE,
    S_read_data_S_read_data_0001,
    S_read_data_S_read_data_0002,
    S_read_data_S_read_data_0003,
    S_read_data_S_read_data_0004,
    S_read_data_S_read_data_0005  
  );
  signal S_read_data : Type_S_read_data := S_read_data_IDLE;
  signal S_read_data_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0017 : std_logic;
  signal tmp_0018 : std_logic;
  signal tmp_0019 : std_logic;
  signal tmp_0020 : std_logic;
  signal tmp_0021 : std_logic;
  signal tmp_0022 : std_logic;
  signal tmp_0023 : std_logic;
  signal tmp_0024 : std_logic;
  signal tmp_0025 : std_logic;
  signal tmp_0026 : std_logic;
  signal tmp_0027 : std_logic;
  signal tmp_0028 : std_logic;
  signal tmp_0029 : std_logic;
  signal tmp_0030 : std_logic;
  signal tmp_0031 : std_logic;
  signal tmp_0032 : std_logic;
  signal tmp_0033 : signed(32-1 downto 0);
  signal test_req_local : std_logic := '0';
  signal tmp_0034 : std_logic;
  signal test_offset_3 : signed(32-1 downto 0) := X"3f000000";
  type Type_S_test is (
    S_test_IDLE,
    S_test_S_test_0001,
    S_test_S_test_0002,
    S_test_S_test_0003,
    S_test_S_test_0004,
    S_test_S_test_0005,
    S_test_S_test_0006,
    S_test_S_test_0007,
    S_test_S_test_0009,
    S_test_S_test_0010,
    S_test_S_test_0012  
  );
  signal S_test : Type_S_test := S_test_IDLE;
  signal S_test_delay : signed(32-1 downto 0) := (others => '0');
  signal tmp_0035 : signed(32-1 downto 0);
  signal tmp_0036 : std_logic;
  signal tmp_0037 : std_logic;
  signal tmp_0038 : signed(32-1 downto 0);
  signal tmp_0039 : std_logic;
  signal tmp_0040 : std_logic;
  signal tmp_0041 : signed(32-1 downto 0);
  signal tmp_0042 : std_logic;
  signal tmp_0043 : std_logic;
  signal tmp_0044 : signed(32-1 downto 0);
  signal tmp_0045 : std_logic;
  signal tmp_0046 : std_logic;
  signal tmp_0047 : std_logic;
  signal tmp_0048 : std_logic;
  signal tmp_0049 : signed(32-1 downto 0);
  signal tmp_0050 : signed(32-1 downto 0);
  signal tmp_0051 : signed(32-1 downto 0);
  signal tmp_0052 : signed(32-1 downto 0);
  signal tmp_0053 : signed(32-1 downto 0);
  signal tmp_0054 : signed(32-1 downto 0);
  signal tmp_0055 : signed(32-1 downto 0);
  signal tmp_0056 : signed(32-1 downto 0);
  signal tmp_0057 : signed(32-1 downto 0);
  signal tmp_0058 : signed(32-1 downto 0);
  signal tmp_0059 : signed(32-1 downto 0);
  signal tmp_0060 : signed(32-1 downto 0);
  signal tmp_0061 : signed(32-1 downto 0);
  signal tmp_0062 : signed(32-1 downto 0);
  signal tmp_0063 : signed(32-1 downto 0);
  signal tmp_0064 : signed(32-1 downto 0);
  signal tmp_0065 : signed(32-1 downto 0);
  signal tmp_0066 : signed(32-1 downto 0);
  signal tmp_0067 : signed(32-1 downto 0);
  signal tmp_0068 : signed(32-1 downto 0);
  signal tmp_0069 : signed(32-1 downto 0);
  signal tmp_0070 : signed(32-1 downto 0);
  signal tmp_0071 : signed(32-1 downto 0);
  signal tmp_0072 : signed(32-1 downto 0);
  signal write_data_busy_sig_0073 : std_logic;
  signal tmp_0074 : std_logic;
  signal tmp_0075 : std_logic;
  signal tmp_0076 : std_logic;
  signal tmp_0077 : std_logic;
  signal tmp_0078 : signed(32-1 downto 0);
  signal tmp_0079 : signed(32-1 downto 0);

begin

  clk_sig <= clk;
  reset_sig <= reset;
  write_data_addr_in_sig <= write_data_addr_in;
  write_data_data_in_sig <= write_data_data_in;
  write_data_req_sig <= write_data_req;
  write_data_busy <= write_data_busy_sig;
  write_data_busy_sig <= tmp_0009;

  read_data_addr_in_sig <= read_data_addr_in;
  read_data_return <= read_data_return_sig;
  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        read_data_return_sig <= (others => '0');
      else
        if S_read_data = S_read_data_S_read_data_0002 then
          read_data_return_sig <= signed(obj_read_result);
        end if;
      end if;
    end if;
  end process;

  read_data_req_sig <= read_data_req;
  read_data_busy <= read_data_busy_sig;
  read_data_busy_sig <= tmp_0030;

  test_req_sig <= test_req;
  test_busy <= test_busy_sig;
  test_busy_sig <= tmp_0048;


  -- expressions
  tmp_0001 <= write_data_req_sig or write_data_req_local;
  tmp_0002 <= '1';
  tmp_0003 <= '1' when obj_busy = tmp_0002 else '0';
  tmp_0004 <= '1' when tmp_0003 = '1' else '0';
  tmp_0005 <= '1';
  tmp_0006 <= '1' when obj_busy = tmp_0005 else '0';
  tmp_0007 <= '1' when tmp_0006 = '0' else '0';
  tmp_0008 <= '1' when S_write_data = S_write_data_IDLE else '0';
  tmp_0009 <= '0' when tmp_0008 = '1' else '1';
  tmp_0010 <= '1' when write_data_req_sig = '1' else '0';
  tmp_0011 <= '1' when write_data_req_sig = '1' else '0';
  tmp_0012 <= write_data_addr_in_sig when tmp_0011 = '1' else write_data_addr;
  tmp_0013 <= '1' when write_data_req_sig = '1' else '0';
  tmp_0014 <= '1' when write_data_req_sig = '1' else '0';
  tmp_0015 <= write_data_data_in_sig when tmp_0014 = '1' else write_data_data;
  tmp_0016 <= read_data_req_sig or read_data_req_local;
  tmp_0017 <= '1';
  tmp_0018 <= '1' when obj_busy = tmp_0017 else '0';
  tmp_0019 <= '1' when tmp_0018 = '1' else '0';
  tmp_0020 <= '1';
  tmp_0021 <= '1' when obj_busy = tmp_0020 else '0';
  tmp_0022 <= '1' when tmp_0021 = '0' else '0';
  tmp_0023 <= '1';
  tmp_0024 <= '1' when obj_busy = tmp_0023 else '0';
  tmp_0025 <= '1' when tmp_0024 = '1' else '0';
  tmp_0026 <= '1';
  tmp_0027 <= '1' when obj_busy = tmp_0026 else '0';
  tmp_0028 <= '1' when tmp_0027 = '0' else '0';
  tmp_0029 <= '1' when S_read_data = S_read_data_IDLE else '0';
  tmp_0030 <= '0' when tmp_0029 = '1' else '1';
  tmp_0031 <= '1' when read_data_req_sig = '1' else '0';
  tmp_0032 <= '1' when read_data_req_sig = '1' else '0';
  tmp_0033 <= read_data_addr_in_sig when tmp_0032 = '1' else read_data_addr;
  tmp_0034 <= test_req_sig or test_req_local;
  tmp_0035 <= X"00000096";
  tmp_0036 <= '1' when test_j_4 < tmp_0035 else '0';
  tmp_0037 <= '1' when tmp_0036 = '0' else '0';
  tmp_0038 <= X"00000096";
  tmp_0039 <= '1' when test_j_4 < tmp_0038 else '0';
  tmp_0040 <= '1' when tmp_0039 = '1' else '0';
  tmp_0041 <= X"0000001e";
  tmp_0042 <= '1' when test_i_2 < tmp_0041 else '0';
  tmp_0043 <= '1' when tmp_0042 = '0' else '0';
  tmp_0044 <= X"0000001e";
  tmp_0045 <= '1' when test_i_2 < tmp_0044 else '0';
  tmp_0046 <= '1' when tmp_0045 = '1' else '0';
  tmp_0047 <= '1' when S_test = S_test_IDLE else '0';
  tmp_0048 <= '0' when tmp_0047 = '1' else '1';
  tmp_0049 <= X"3f000000";
  tmp_0050 <= X"00000078";
  tmp_0051 <= X"0000000a";
  tmp_0052 <= test_j_4(21 downto 0) & (10-1 downto 0 => '0');
  tmp_0053 <= X"00000009";
  tmp_0054 <= test_j_4(22 downto 0) & (9-1 downto 0 => '0');
  tmp_0055 <= tmp_0052 + tmp_0054;
  tmp_0056 <= X"00000008";
  tmp_0057 <= test_j_4(23 downto 0) & (8-1 downto 0 => '0');
  tmp_0058 <= tmp_0055 + tmp_0057;
  tmp_0059 <= X"00000007";
  tmp_0060 <= test_j_4(24 downto 0) & (7-1 downto 0 => '0');
  tmp_0061 <= tmp_0058 + tmp_0060;
  tmp_0062 <= X"00000001";
  tmp_0063 <= test_y_1(30 downto 0) & (1-1 downto 0 => '0');
  tmp_0064 <= tmp_0063 + test_y_1;
  tmp_0065 <= X"00000000";
  tmp_0066 <= X"00000078";
  tmp_0067 <= X"00000002";
  tmp_0068 <= test_i_2(29 downto 0) & (2-1 downto 0 => '0');
  tmp_0069 <= tmp_0066 + tmp_0068;
  tmp_0070 <= tmp_0069 + test_y_1;
  tmp_0071 <= test_pt_0 + test_offset_3;
  tmp_0072 <= X"ffffffff";
  tmp_0074 <= '1' when write_data_busy_sig = '0' else '0';
  tmp_0075 <= '1' when write_data_req_local = '0' else '0';
  tmp_0076 <= tmp_0074 and tmp_0075;
  tmp_0077 <= '1' when tmp_0076 = '1' else '0';
  tmp_0078 <= test_i_2 + 1;
  tmp_0079 <= test_j_4 + 1;

  -- sequencers
  process (clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        S_write_data <= S_write_data_IDLE;
        S_write_data_delay <= (others => '0');
      else
        case (S_write_data) is
          when S_write_data_IDLE => 
            if tmp_0001 = '1' then
              S_write_data <= S_write_data_S_write_data_0003;
            end if;
          when S_write_data_S_write_data_0001 => 
            S_write_data <= S_write_data_IDLE;
          when S_write_data_S_write_data_0002 => 
            S_write_data <= S_write_data_S_write_data_0001;
          when S_write_data_S_write_data_0003 => 
            if tmp_0004 = '1' then
              S_write_data <= S_write_data_S_write_data_0003;
            elsif tmp_0007 = '1' then
              S_write_data <= S_write_data_S_write_data_0002;
            end if;
          when others => null;
        end case;
      end if;
    end if;
  end process;

  process (clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        S_read_data <= S_read_data_IDLE;
        S_read_data_delay <= (others => '0');
      else
        case (S_read_data) is
          when S_read_data_IDLE => 
            if tmp_0016 = '1' then
              S_read_data <= S_read_data_S_read_data_0005;
            end if;
          when S_read_data_S_read_data_0001 => 
            S_read_data <= S_read_data_IDLE;
          when S_read_data_S_read_data_0002 => 
            S_read_data <= S_read_data_S_read_data_0001;
          when S_read_data_S_read_data_0003 => 
            if tmp_0019 = '1' then
              S_read_data <= S_read_data_S_read_data_0003;
            elsif tmp_0022 = '1' then
              S_read_data <= S_read_data_S_read_data_0002;
            end if;
          when S_read_data_S_read_data_0004 => 
            if S_read_data_delay >= 2 then
              S_read_data_delay <= (others => '0');
              S_read_data <= S_read_data_S_read_data_0003;
            else
              S_read_data_delay <= S_read_data_delay + 1;
            end if;
          when S_read_data_S_read_data_0005 => 
            if tmp_0025 = '1' then
              S_read_data <= S_read_data_S_read_data_0005;
            elsif tmp_0028 = '1' then
              S_read_data <= S_read_data_S_read_data_0004;
            end if;
          when others => null;
        end case;
      end if;
    end if;
  end process;

  process (clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        S_test <= S_test_IDLE;
        S_test_delay <= (others => '0');
      else
        case (S_test) is
          when S_test_IDLE => 
            if tmp_0034 = '1' then
              S_test <= S_test_S_test_0012;
            end if;
          when S_test_S_test_0001 => 
            S_test <= S_test_IDLE;
          when S_test_S_test_0002 => 
            if tmp_0037 = '1' then
              S_test <= S_test_S_test_0001;
            elsif tmp_0040 = '1' then
              S_test <= S_test_S_test_0010;
            end if;
          when S_test_S_test_0003 => 
            S_test <= S_test_S_test_0002;
          when S_test_S_test_0004 => 
            if tmp_0043 = '1' then
              S_test <= S_test_S_test_0003;
            elsif tmp_0046 = '1' then
              S_test <= S_test_S_test_0007;
            end if;
          when S_test_S_test_0005 => 
            S_test <= S_test_S_test_0004;
          when S_test_S_test_0006 => 
            if S_test_delay >= 1 and write_data_busy_sig_0073 = '1' then
              S_test_delay <= (others => '0');
              S_test <= S_test_S_test_0005;
            else
              S_test_delay <= S_test_delay + 1;
            end if;
          when S_test_S_test_0007 => 
            S_test <= S_test_S_test_0006;
          when S_test_S_test_0009 => 
            S_test <= S_test_S_test_0004;
          when S_test_S_test_0010 => 
            S_test <= S_test_S_test_0009;
          when S_test_S_test_0012 => 
            S_test <= S_test_S_test_0002;
          when others => null;
        end case;
      end if;
    end if;
  end process;


  obj_clk <= clk_sig;

  obj_reset <= reset_sig;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        obj_data_address <= (others => '0');
      else
        if S_write_data = S_write_data_S_write_data_0002 then
          obj_data_address <= std_logic_vector(write_data_addr);
        elsif S_read_data = S_read_data_S_read_data_0004 and S_read_data_delay = 0 then
          obj_data_address <= std_logic_vector(read_data_addr);
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        obj_data_din <= (others => '0');
      else
        if S_write_data = S_write_data_S_write_data_0002 then
          obj_data_din <= std_logic_vector(write_data_data);
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        obj_data_we <= '0';
      else
        if S_write_data = S_write_data_S_write_data_0002 then
          obj_data_we <= '1';
        elsif S_read_data = S_read_data_S_read_data_0004 and S_read_data_delay >= 2 then
          obj_data_we <= '0';
        else
          obj_data_we <= '0';
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        obj_data_oe <= '0';
      else
        if S_read_data = S_read_data_S_read_data_0004 and S_read_data_delay = 0 then
          obj_data_oe <= '1';
        else
          obj_data_oe <= '0';
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        test_j_4 <= X"00000078";
      else
        if S_test = S_test_S_test_0012 then
          test_j_4 <= tmp_0050;
        elsif S_test = S_test_S_test_0003 then
          test_j_4 <= tmp_0079;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        test_y_1 <= (others => '0');
      else
        if S_test = S_test_S_test_0010 then
          test_y_1 <= tmp_0061;
        elsif S_test = S_test_S_test_0009 then
          test_y_1 <= tmp_0064;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        test_i_2 <= X"00000000";
      else
        if S_test = S_test_S_test_0010 then
          test_i_2 <= tmp_0065;
        elsif S_test = S_test_S_test_0005 then
          test_i_2 <= tmp_0078;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        test_pt_0 <= (others => '0');
      else
        if S_test = S_test_S_test_0007 then
          test_pt_0 <= tmp_0070;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        write_data_addr <= (others => '0');
      else
        if S_write_data = S_write_data_IDLE and tmp_0010 = '1' then
          write_data_addr <= tmp_0012;
        elsif S_test = S_test_S_test_0006 and S_test_delay = 0 then
          write_data_addr <= tmp_0071;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        write_data_data <= (others => '0');
      else
        if S_write_data = S_write_data_IDLE and tmp_0013 = '1' then
          write_data_data <= tmp_0015;
        elsif S_test = S_test_S_test_0006 and S_test_delay = 0 then
          write_data_data <= tmp_0072;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        write_data_req_local <= '0';
      else
        if S_test = S_test_S_test_0006 and S_test_delay = 0 then
          write_data_req_local <= '1';
        else
          write_data_req_local <= '0';
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        read_data_addr <= (others => '0');
      else
        if S_read_data = S_read_data_IDLE and tmp_0031 = '1' then
          read_data_addr <= tmp_0033;
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        read_data_req_local <= '0';
      else
        read_data_req_local <= '0';
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        read_data_v_1 <= (others => '0');
      else
        if S_read_data = S_read_data_S_read_data_0004 and S_read_data_delay >= 2 then
          read_data_v_1 <= signed(obj_data_dout);
        end if;
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        test_req_local <= '0';
      else
        test_req_local <= '0';
      end if;
    end if;
  end process;

  process(clk)
  begin
    if clk'event and clk = '1' then
      if reset = '1' then
        test_offset_3 <= X"3f000000";
      else
        if S_test = S_test_S_test_0012 then
          test_offset_3 <= tmp_0049;
        end if;
      end if;
    end if;
  end process;

  write_data_busy_sig_0073 <= tmp_0077;


  inst_obj : simple_axi_memiface_32
  port map(
    clk => obj_clk,
    reset => obj_reset,
    data_address => obj_data_address,
    data_din => obj_data_din,
    data_dout => obj_data_dout,
    read_result => obj_read_result,
    data_we => obj_data_we,
    data_oe => obj_data_oe,
    data_length => obj_data_length,
    busy => obj_busy,
    forbid => obj_forbid,
    axi_reader_ARADDR => obj_axi_reader_ARADDR,
    axi_reader_ARLEN => obj_axi_reader_ARLEN,
    axi_reader_ARVALID => obj_axi_reader_ARVALID,
    axi_reader_ARREADY => obj_axi_reader_ARREADY,
    axi_reader_ARSIZE => obj_axi_reader_ARSIZE,
    axi_reader_ARBURST => obj_axi_reader_ARBURST,
    axi_reader_ARCACHE => obj_axi_reader_ARCACHE,
    axi_reader_ARPROT => obj_axi_reader_ARPROT,
    axi_reader_RDATA => obj_axi_reader_RDATA,
    axi_reader_RRESP => obj_axi_reader_RRESP,
    axi_reader_RLAST => obj_axi_reader_RLAST,
    axi_reader_RVALID => obj_axi_reader_RVALID,
    axi_reader_RREADY => obj_axi_reader_RREADY,
    axi_writer_AWADDR => obj_axi_writer_AWADDR,
    axi_writer_AWLEN => obj_axi_writer_AWLEN,
    axi_writer_AWVALID => obj_axi_writer_AWVALID,
    axi_writer_AWSIZE => obj_axi_writer_AWSIZE,
    axi_writer_AWBURST => obj_axi_writer_AWBURST,
    axi_writer_AWCACHE => obj_axi_writer_AWCACHE,
    axi_writer_AWPROT => obj_axi_writer_AWPROT,
    axi_writer_AWREADY => obj_axi_writer_AWREADY,
    axi_writer_WDATA => obj_axi_writer_WDATA,
    axi_writer_WLAST => obj_axi_writer_WLAST,
    axi_writer_WVALID => obj_axi_writer_WVALID,
    axi_writer_WREADY => obj_axi_writer_WREADY,
    axi_writer_WSTRB => obj_axi_writer_WSTRB,
    axi_writer_BRESP => obj_axi_writer_BRESP,
    axi_writer_BVALID => obj_axi_writer_BVALID,
    axi_writer_BREADY => obj_axi_writer_BREADY
  );


end RTL;
